﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IOTransmissionAbutment
{
    public partial class GeneralSetting : Form
    {
        public GeneralSetting()
        {
            InitializeComponent();
            txtServerIP.Text = DeviceManager.ServerIP;
            txtServerPort.Text = DeviceManager.ServerPort.ToString();
            Regieter();
            //LocalizationTool.localizeForm(this);
        }
        void Regieter()
        {
            btnOK.Click += BtnOK_Click;
            btnCancel.Click += BtnCancel_Click;
        }

        private void BtnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void BtnOK_Click(object sender, EventArgs e)
        {
            string ip = txtServerIP.Text.Trim();
            string port = txtServerPort.Text.Trim();
            IPAddress temp;
            if (!IPAddress.TryParse(ip, out temp))
            {
                MessageBox.Show("无效的IP地址！");
                //MessageBox.Show(LocalizationTool.getMessage("msgDevicesAbutmentmsg0008"));
                return;
            }
            int portInt = -1;

            int.TryParse(port, out portInt);
            if (portInt < 0 || portInt > 65535)
            {
                MessageBox.Show("无效的端口号，其有效范围为0-65535");
                //MessageBox.Show(LocalizationTool.getMessage("msgDevicesAbutmentmsg0027"));
                return;
            }
            bool IsChanged = false;
            if (ip != DeviceManager.ServerIP)
            {
                using (var session = ModelHelper.Session)
                {
                   var serverip = DeviceManager.listGeneral.FindLast(p => p.Name == "ServerIP");
                    if(serverip != null)
                    {
                        serverip.Content = ip;
                        session.SaveOrUpdate(serverip);
                        session.Flush();
                    }
                    else
                    {
                        General newGeneral = new General() { Name = "ServerIP", Content = ip };
                        session.SaveOrUpdate(newGeneral);
                        session.Flush();
                    }
                }
                //DeviceManager.ServerIP = ip;
                IsChanged = true;
            }
            if (portInt != DeviceManager.ServerPort)
            {
                using (var session = ModelHelper.Session)
                {
                    var serverport = DeviceManager.listGeneral.FindLast(p => p.Name == "ServerPort");
                    if (serverport != null)
                    {
                        serverport.Content = port;
                        session.SaveOrUpdate(serverport);
                        session.Flush();
                    }
                    else
                    {
                        General newGeneral = new General() {Name= "ServerPort",Content=port };
                        session.SaveOrUpdate(newGeneral);
                        session.Flush();
                    }
                }
                //DeviceManager.ServerPort = portInt;
                IsChanged = true;
            }
            if (IsChanged)
            {
                MessageBox.Show("监听设置已改变，重启SystemManager后生效！");
                //MessageBox.Show(LocalizationTool.getMessage("msgDevicesAbutmentmsg0028"));
            }
            this.Close();
        }
    }
}
