﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IOTransmissionAbutment
{
    public enum StatusType
    {
        充电站,
        门,
        电梯,
        电梯层,
        线边滚筒
    }
    public abstract class GridViewContent : IDisposable
    {
        private DataGridView _MainDGV = null;
        private StatusType _Type;

        public DataGridView MainDGV { get { return _MainDGV; } }
        public StatusType Type { get { return _Type; } protected set { _Type = value; } }

        public abstract DataTable UpdateHeader();
        public abstract void UpdateData(DataTable table);
        public abstract void OnDispose();

        public void SetManager(DataGridView dgv)
        {
            _MainDGV = dgv;
        }

        public void Dispose()
        {
            OnDispose();

            _MainDGV = null;
        }
    }
}
