﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IOTransmissionAbutment
{
    public class TCPServer
    {
        public static Action<string> ReceiveReport = null;
        public static Action<int,byte[]> DataAnalysisAction = null;
        public ConcurrentDictionary<string, Socket> dictClients = new ConcurrentDictionary<string, Socket>();
        public ConcurrentDictionary<string, Socket> dictOnlineClients = new ConcurrentDictionary<string, Socket>();
        Dictionary<string, Thread> dictThread = new Dictionary<string, Thread>();
        Dictionary<int, List<byte>> devicesBuffers = new Dictionary<int, List<byte>>();
        Socket socketWatch = null;
        Thread threadWatch = null;
        byte[] m_byLastarrMsg = new byte[14];
        public void WatchThread()
        {
            if (DeviceManager.dictDevice.Values != null)
            {
                foreach (var item in DeviceManager.dictDevice.Keys)
                {
                    devicesBuffers[item] = new List<byte>();
                }
            }
            DeviceManager.DeviceRemoved += DeviceRemoved;
            DeviceManager.DeviceAdded += DeviceAdded;
            DeviceManager.DeviceUpdated += DeviceIPUpadated;
            try
            {
                socketWatch = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                IPEndPoint endPoint = new IPEndPoint(IPAddress.Parse(DeviceManager.ServerIP), DeviceManager.ServerPort);
                socketWatch.Bind(endPoint);
                socketWatch.Listen(10);
                threadWatch = new Thread(WatchConnecting);
                threadWatch.IsBackground = true;
                threadWatch.Start();
            }
            catch(Exception ex)
            {
                MessageBox.Show("服务监听IP无效，请更改为本机IP后重启SystemManager！");
                //MessageBox.Show(LocalizationTool.getMessage("msgDevicesAbutmentTCPServerIPException"));
                //Console.WriteLine("出错了...");
            }
        }
        void DeviceAdded(Device device)
        {
            devicesBuffers[device.ID] = new List<byte>();
        }
        void DeviceIPUpadated(Device device)
        {
            devicesBuffers[device.ID] = new List<byte>();
        }
        void DeviceRemoved(int id, DeviceType type = DeviceType.None)
        {
            if (devicesBuffers.ContainsKey(id))
            {
                devicesBuffers.Remove(id);
            }
        }
        ///<summary>
        ///监听客户端请求的方法；
        ///</summary>
        void WatchConnecting()
        {
            while (true)  // 持续不断的监听客户端的连接请求；
            {
                // 开始监听客户端连接请求，Accept方法会阻断当前的线程；
                Socket sokConnection = socketWatch.Accept(); // 一旦监听到一个客户端的请求，就返回一个与该客户端通信的 套接字；  
                                                             // 想列表控件中添加客户端的IP信息；

                if (sokConnection != null && sokConnection.Connected)
                {
                    string reIp = sokConnection.RemoteEndPoint.ToString().Split(':')[0];
                    if (!dictOnlineClients.Values.Contains(sokConnection))
                    {
                        dictOnlineClients[reIp] = sokConnection;
                    }
                    foreach (string ip in dictThread.Keys)
                    {
                        if (ip.Contains(reIp))
                        {
                            dictThread[ip].Abort();
                            dictThread.Remove(ip);
                            //CRunningEngine.Instance.Log.WriteLog("RemoveThreadIP", reIp);
                            break;
                        }
                    }
                    //dict.Add(sokConnection.RemoteEndPoint.ToString(), sokConnection);
                    //ShowMsg("客户端连接成功！");
                    Thread thr = new Thread(RecMsg);
                    thr.IsBackground = true;
                    thr.Start(sokConnection);
                    dictClients.TryAdd(sokConnection.RemoteEndPoint.ToString(), sokConnection);
                    dictThread.Add(sokConnection.RemoteEndPoint.ToString(), thr);  //  将新建的线程 添加 到线程的
                    //CRunningEngine.Instance.Log.WriteLog("ADDThreadIP", sokConnection.RemoteEndPoint.ToString());
                }
                Thread.Sleep(500);
            }
        }

        void RecMsg(object sokConnectionparn)
        {
            Socket sokClient = sokConnectionparn as Socket;
            string reIp = sokClient.RemoteEndPoint.ToString().Split(':')[0];
            //Device device = DeviceManager.dictDevice.Values.First(p => p.IPAddress == reIp);
            //if (device != null)
            {
                //int deviceid = device.ID;
                while (true)
                {
                    // 定义一个2M的缓存区；
                    // 将接受到的数据存入到输入  arrMsgRec中；
                    byte[] arrMsgRec = new byte[1024 * 1024 * 2];
                    int length = -1;
                    try
                    {
                        length = sokClient.Receive(arrMsgRec); // 接收数据，并返回数据的长度；
                    }
                    catch (SocketException se)
                    {
                        //Device device = DeviceManager.dictDevice.Values.First(p => p.IPAddress == reIp);
                        //if (device != null)
                        //{
                        //    if (devicesBuffers.Keys.Contains(device.ID))
                        //    {
                        //        devicesBuffers.Remove(device.ID);
                        //    }
                        //}
                        //MessageBox.Show("异常：" + se.Message);
                        // 从 通信套接字 集合中删除被中断连接的通信套接字；
                        Socket socket;
                        dictClients.TryRemove(sokClient.RemoteEndPoint.ToString(), out socket);
                        // 从通信线程集合中删除被中断连接的通信线程对象；
                        dictThread.Remove(sokClient.RemoteEndPoint.ToString());
                        // 从列表中移除被中断的连接IP
                        if (sokClient != null)
                        {
                            dictOnlineClients.TryRemove(reIp, out socket);

                        }
                        //CRunningEngine.Instance.Log.WriteLog("RemoveThreadIP1", sokClient.RemoteEndPoint.ToString());
                        break;
                    }
                    catch (Exception e)
                    {
                        //Device device = DeviceManager.dictDevice.Values.First(p => p.IPAddress == reIp);
                        //if (device != null)
                        //{
                        //    if (devicesBuffers.Keys.Contains(device.ID))
                        //    {
                        //        devicesBuffers.Remove(device.ID);
                        //    }
                        //}
                        //MessageBox.Show("异常：" + e.Message);
                        // 从 通信套接字 集合中删除被中断连接的通信套接字；
                        Socket socket;
                        dictClients.TryRemove(sokClient.RemoteEndPoint.ToString(), out socket);
                        // 从通信线程集合中删除被中断连接的通信线程对象；
                        dictThread.Remove(sokClient.RemoteEndPoint.ToString());
                        // 从列表中移除被中断的连接IP
                        dictOnlineClients.TryRemove(reIp, out socket);
                        //CRunningEngine.Instance.Log.WriteLog("RemoveThreadIP2", sokClient.RemoteEndPoint.ToString());
                        break;
                    }
                    if (length > 0)
                    {
                        string strReceive = BitConverter.ToString(arrMsgRec, 0, length).Replace("-", " ");
                        strReceive = string.Format("Receive from {0}-->:{1}", reIp, strReceive);
                        if (ReceiveReport != null)
                        {
                            ReceiveReport(strReceive);
                        }
                        Device device = null;
                        try
                        {
                            device = DeviceManager.dictDevice.Values.First(p => p.IPAddress == reIp);
                        }
                        catch
                        {
                            continue;
                        }
                        if (device != null)
                        {
                            int deviceid = device.ID;
                            byte[] BufAGV1 = new byte[length];
                            for (int m = 0; m < BufAGV1.Length; m++)
                            {
                                BufAGV1[m] = arrMsgRec[m];
                            }
                            if (devicesBuffers.ContainsKey(deviceid) && devicesBuffers[deviceid] != null)
                            {
                                devicesBuffers[deviceid].Clear();
                                devicesBuffers[deviceid].AddRange(BufAGV1);
                                byte[] Receive;

                                
                                if (devicesBuffers[deviceid].Count >= 14)//数据解析 2018-03-20 李小飞添加
                                {
                                    if (devicesBuffers[deviceid][0] == 0x10 && devicesBuffers[deviceid][13] == 0x03)
                                    {
                                        byte checksum = 0;
                                        for (int i = 0; i < 12; i++)
                                        {
                                            checksum ^= devicesBuffers[deviceid][i];
                                        }
                                        if (devicesBuffers[deviceid][12] == checksum)
                                        {
                                            Receive = new byte[14];
                                            for (int i = 0; i < 14; i++)
                                            {
                                                Receive[i] = devicesBuffers[deviceid][i];
                                            }
                                            //if ((int)device.Type != (int)Receive[1])
                                            if ((int)0x81 != (int)Receive[1])
                                            {
                                                ArrangeBuffer(devicesBuffers[deviceid], 0x10);
                                                continue;
                                            }
                                            
                                            switch (device.Type)
                                            {
                                                case DeviceType.Other:
                                                    IOTransmissionDevice gDevice = device as IOTransmissionDevice;
                                                    if (gDevice != null)
                                                    {
                                                        gDevice.ReceiveBytes = Receive;
                                                    }
                                                    break;
                                                default:
                                                    break;
                                            }
                                            ArrangeBuffer(devicesBuffers[deviceid], 0x10);
                                        }
                                        else
                                        {
                                            ArrangeBuffer(devicesBuffers[deviceid], 0x10);
                                        }
                                    }
                                    else
                                    {
                                        ArrangeBuffer(devicesBuffers[deviceid], 0x10);
                                    }
                                }
                            }
                        }
                        else
                        {
                            strReceive = string.Format("No device could match the data from {0}", reIp);
                            if (ReceiveReport != null)
                            {
                                ReceiveReport(strReceive);
                            }
                        }
                    }
                }
                Thread.Sleep(50);
            }

        }

        //void RecMsg(object sokConnectionparn)
        //{
        //    Socket sokClient = sokConnectionparn as Socket;
        //    string reIp = sokClient.RemoteEndPoint.ToString().Split(':')[0];
        //    Device device = DeviceManager.dictDevice.Values.First(p => p.IPAddress == reIp);
        //    if (device != null)
        //    {
        //        int deviceid = device.ID;
        //        while (true)
        //        {
        //            // 定义一个2M的缓存区；
        //            // 将接受到的数据存入到输入  arrMsgRec中；
        //            byte[] arrMsgRec = new byte[1024 * 1024 * 2];
        //            int length = -1;
        //            try
        //            {
        //                length = sokClient.Receive(arrMsgRec); // 接收数据，并返回数据的长度；
        //            }
        //            catch (SocketException se)
        //            {
        //                //MessageBox.Show("异常：" + se.Message);
        //                // 从 通信套接字 集合中删除被中断连接的通信套接字；
        //                Socket socket;
        //                dictClients.TryRemove(sokClient.RemoteEndPoint.ToString(), out socket);
        //                // 从通信线程集合中删除被中断连接的通信线程对象；
        //                dictThread.Remove(sokClient.RemoteEndPoint.ToString());
        //                // 从列表中移除被中断的连接IP
        //                if (sokClient != null)
        //                {
        //                    dictOnlineClients.TryRemove(reIp, out socket);

        //                }
        //                //CRunningEngine.Instance.Log.WriteLog("RemoveThreadIP1", sokClient.RemoteEndPoint.ToString());
        //                break;
        //            }
        //            catch (Exception e)
        //            {
        //                //MessageBox.Show("异常：" + e.Message);
        //                // 从 通信套接字 集合中删除被中断连接的通信套接字；
        //                Socket socket;
        //                dictClients.TryRemove(sokClient.RemoteEndPoint.ToString(), out socket);
        //                // 从通信线程集合中删除被中断连接的通信线程对象；
        //                dictThread.Remove(sokClient.RemoteEndPoint.ToString());
        //                // 从列表中移除被中断的连接IP
        //                dictOnlineClients.TryRemove(reIp, out socket);
        //                //CRunningEngine.Instance.Log.WriteLog("RemoveThreadIP2", sokClient.RemoteEndPoint.ToString());
        //                break;
        //            }
        //            if (length > 0)
        //            {
        //                byte[] BufAGV1 = new byte[length];
        //                for (int m = 0; m < BufAGV1.Length; m++)
        //                {
        //                    BufAGV1[m] = arrMsgRec[m];
        //                }
        //                BufAGV.AddRange(BufAGV1);
        //                byte[] Receive;
        //                if (BufAGV.Count >= 14)//数据解析 2018-03-20 李小飞添加
        //                {
        //                    if (BufAGV[0] == 0x10 && BufAGV[13] == 0x03)
        //                    {
        //                        byte checksum = 0;
        //                        for (int i = 0; i < 12; i++)
        //                        {
        //                            checksum ^= BufAGV[i];
        //                        }
        //                        if (BufAGV[12] == checksum)
        //                        {
        //                            Receive = new byte[14];
        //                            for (int i = 0; i < 14; i++)
        //                            {
        //                                Receive[i] = BufAGV[i];
        //                            }
        //                            if ((int)device.Type != (int)Receive[1])
        //                            {
        //                                ArrangeBuffer(BufAGV, 0x10);
        //                                continue;
        //                            }
        //                            int d1 = Receive[2];
        //                            int d2 = Receive[3];
        //                            int d3 = Receive[4];
        //                            switch (device.Type)
        //                            {
        //                                case DeviceType.PowerStation:
        //                                    PowerStationDevice pDevice = device as PowerStationDevice;
        //                                    if (pDevice != null)
        //                                    {
        //                                        pDevice.PileStatus = (PileStatus)d1;
        //                                        pDevice.AlarmStatus = (AlarmStatus)d2;
        //                                        pDevice.ChargingStatus = (ChargingStatus)d3;
        //                                    }
        //                                    break;
        //                                case DeviceType.Gate:
        //                                    GateDevice gDevice = device as GateDevice;
        //                                    if (gDevice != null)
        //                                    {
        //                                        gDevice.Status = (GateStatus)d1;
        //                                    }
        //                                    break;
        //                                case DeviceType.Elevator:
        //                                    ElevatorDevice eDevice = device as ElevatorDevice;
        //                                    if (eDevice != null)
        //                                    {
        //                                        eDevice.Status = (ElevatorStatus)d1;
        //                                    }
        //                                    break;
        //                                default:
        //                                    break;
        //                            }
        //                            ArrangeBuffer(BufAGV, 0x10);
        //                        }
        //                        else
        //                        {
        //                            ArrangeBuffer(BufAGV, 0x10);
        //                        }
        //                    }
        //                    else
        //                    {
        //                        ArrangeBuffer(BufAGV, 0x10);
        //                    }
        //                }
        //            }
        //            Thread.Sleep(50);
        //        }
        //    }
        //}

        private void ArrangeBuffer(List<byte> bufferList, byte targetByte)
        {
            int delBytes = 1;

            for (int i = 1; i < bufferList.Count; i++)
            {
                if (bufferList[i] == targetByte)
                {
                    break;
                }
                else
                {
                    delBytes++;
                }
            }
            try
            {
                bufferList.RemoveRange(0, delBytes);
            }
            catch (System.Exception ex)
            {
                //string infoStr = "delete byte error: " + ex.Message.ToString();
                //CRunningEngine.Instance.Log.WriteLog("Error", infoStr);
                //CDebug.ShowDebugInfo(infoStr);
            }
        }
    }
}
