﻿using FluentNHibernate.Mapping;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IOTransmissionAbutment
{
    public class CSendDataTimes
    {
        public byte Value = 0;
        public int SendTimes = 0;
        public bool bNeedRemove = false;
        public byte ValueLandMark = 0;
        public byte Agv = 0;
    }
     

    public class CallBoxSetting
    {
       
        private int _CallBoxNo;
        private int _CallBoxType;
        private string _WareHouseID;

        public CallBoxSetting()
        {

        }
        public CallBoxSetting(int callbox, int type, string warehouseid)
        {
            CallBoxNo = callbox;
            CallBoxType = type;
            WareHouseID = warehouseid;
        }
        public virtual int CallBoxNo
        {
            get
            {
                return _CallBoxNo;
            }

            set
            {
                _CallBoxNo = value;
            }
        }


        public virtual int CallBoxType
        {
            get
            {
                return _CallBoxType;
            }

            set
            {
                _CallBoxType = value;
            }
        }
        

        public virtual string WareHouseID
        {
            get
            {
                return _WareHouseID;
            }

            set
            {
                _WareHouseID = value;
            }
        }
       
    }

    class MappingCallBoxSetting : ClassMap<CallBoxSetting>
    {
        public MappingCallBoxSetting()
        {
            Table("CallBoxSetting");
            Id(m => m.CallBoxNo).GeneratedBy.Assigned();//.Increment();
            Map(m => m.CallBoxType);
            Map(m => m.WareHouseID);
        }
    }

    public class WareHouseCallStatus
    {
        private string _WareHouseID;
        private int _CallType;
        private DateTime _Timestamp;//时间戳，在该时间6s以外时间叫料，叫料信号有效
        private int _CallState;//0:空闲，1：产生叫料，2：任务已产生(派车中)
        private int _Carrier;

        public WareHouseCallStatus()
        {

        }
        public WareHouseCallStatus(string warehouse, int calltype, int callstate, DateTime time, int carrier = 0)
        {
            _WareHouseID = warehouse;
            _CallType = calltype;
            _CallState = callstate;
            _Timestamp = time;
            _Carrier = carrier;
        }
        public virtual string WareHouseID
        {
            get
            {
                return _WareHouseID;
            }

            set
            {
                _WareHouseID = value;
            }
        }


        public virtual int CallType
        {
            get
            {
                return _CallType;
            }

            set
            {
                _CallType = value;
            }
        }

        public virtual int CallState
        {
            get
            {
                return _CallState;
            }

            set
            {
                _CallState = value;
            }
        }
        public virtual int Carrier
        {
            get
            {
                return _Carrier;
            }

            set
            {
                _Carrier = value;
            }
        }

        public virtual DateTime Timestamp
        {
            get
            {
                return _Timestamp;
            }

            set
            {
                _Timestamp = value;
            }
        }
        public virtual void RefreshTimestamp()
        {
            _Timestamp = DateTime.Now;
        }
    }

    class MappingWareHouseCallStatus : ClassMap<WareHouseCallStatus>
    {
        public MappingWareHouseCallStatus()
        {
            Table("WareHouseCallStatus");
            Id(m => m.WareHouseID).GeneratedBy.Assigned();//.Increment();
            Map(m => m.CallType);
            Map(m => m.CallState);
            Map(m => m.Carrier);
            Map(m => m.Timestamp);
        }
    }
    //class ElevatorChoice
    //{
    //    public int UID;
    //    public int Mode;
    //}

    public class ElevatorChoice
    {
        private int _UID;
        private int _Mode;


        public virtual int UID
        {
            get
            {
                return _UID;
            }

            set
            {
                _UID = value;
            }
        }


        public virtual int Mode
        {
            get
            {
                return _Mode;
            }

            set
            {
                _Mode = value;
            }
        }

    }

    class MappingElevatorChoice : ClassMap<ElevatorChoice>
    {
        public MappingElevatorChoice()
        {
            Table("ElevatorChoice");
            Id(m => m.UID).GeneratedBy.Increment();//.Increment();
            Map(m => m.Mode);
        }
    }
}
