﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IOTransmissionAbutment
{
    public partial class frmMain : Form
    {
        IOTransmissionAbutmentForm frmGates = new IOTransmissionAbutmentForm();
        
        DebugForm frmDebug = new DebugForm();
        bool canshow = false;
        private static frmMain _MainForm = null;
        public static frmMain ShowForm()
        {
            if (_MainForm == null)
            {
                _MainForm = new frmMain();
                _MainForm.FormClosed += _MainForm_FormClosed;
                _MainForm.WindowState = FormWindowState.Maximized;
                _MainForm.Show();
            }
            else
            {
                _MainForm.Activate();
            }
            return _MainForm;
        }

        private static void _MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            _MainForm = null;
        }

        public frmMain()
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
            MakeCards();
            Registers();
            pnlMain.Tag = btnGates.BackColor;
            BtnGates_Click(null, null);
            //LocalizationTool.localizeForm(this);
        }
        private void MakeCards()
        {
            //制作门对接管理选项卡
            frmGates.TopLevel = false;
            frmGates.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            frmGates.Dock = DockStyle.Fill;
            frmGates.Visible = false;
            pnlMain.Controls.Add(frmGates);

            

            //制作调试数据选项卡
            frmDebug.TopLevel = false;
            frmDebug.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            frmDebug.Dock = DockStyle.Fill;
            //frmPowerStations.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
            pnlMain.Controls.Add(frmDebug);

            
        }
        private void Registers()
        {
            btnGates.Click += BtnGates_Click;
            btnServerSetting.Click += BtnServerSetting_Click;
            btnDebug.Click += BtnDebug_Click;
        }

        private void BtnDebug_Click(object sender, EventArgs e)
        {
            if (!canshow)
            {
                frmBeforeDebug frm = new frmBeforeDebug();
                frm.ResultOutPutHandler += ResultOutPutHandler;
                frm.ShowDialog();
                Thread.Sleep(100);
            }
            if (canshow)
            {
                frmDebug.Visible = true;
                frmGates.Visible = false;
                btnDebug.BackColor = frmGates.BackColor;
                btnGates.BackColor = (Color)pnlMain.Tag;
            }
        }
        void ResultOutPutHandler(bool result)
        {
            canshow = result;
        }
        private void BtnServerSetting_Click(object sender, EventArgs e)
        {
            GeneralSetting GeneralSetting = new GeneralSetting();
            GeneralSetting.StartPosition = FormStartPosition.CenterScreen;
            GeneralSetting.ShowDialog();
        }

        

        private void BtnGates_Click(object sender, EventArgs e)
        {
            frmGates.Visible = true;
            frmDebug.Visible = false;
            btnGates.BackColor = frmGates.BackColor;
            btnDebug.BackColor = (Color)pnlMain.Tag;
        }

        private void BtnElevators_Click(object sender, EventArgs e)
        {
            frmGates.Visible = false;
            frmDebug.Visible = false;
            btnGates.BackColor = (Color)pnlMain.Tag;
            btnDebug.BackColor = (Color)pnlMain.Tag;
        }
    }
}
