﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing;
using System.Security.Cryptography;
using PMSUI.Config;

namespace PMSUI
{
    [Serializable]
    static public  class CasunUILib
    {
        public enum EForms
        {
            Login,
            Prompt,
            MainForm,
            MenuSetting,
            FormSetting,

            UserSetting = 20,
            PermissionSetting,

            WarehouseSetting,
            WarehouseTypeSetting,
            StationIDRelateSetting,

            TaskBookTemplateSetting,
            StepBookTemplateSetting,
            BehaviorSetting,

            HistoryOrderDataQuery,
            HistoryTaskBookQuery,
            HistoryStepBookQuery,

            SystemReset,
            OrderExceptionHandling,

            LanguageSetting,
            DisplaySetting,

            FrmDeletePadTask,
        }

        /// <summary>
        /// 字符串转int32  
        /// 字符串异常时返回0
        /// </summary>
        /// <param name="inPutValue"></param>
        /// <returns></returns>
        public static int StringToInt32(string inPutValue)
        {
            int ret;
            if(int.TryParse(inPutValue, out ret))
            {
                return ret;
            }
            else
            {
                return 0;
            }
        }

        //public static System.Drawing.Color g_FormBackColor = System.Drawing.Color.WhiteSmoke;
        //public static System.Drawing.Color g_FormBackColor = System.Drawing.Color.LightSkyBlue;
        //public static System.Drawing.Color g_FormBackColor = System.Drawing.Color.Azure;
        public static System.Drawing.Color g_FormBackColor = Color.FromArgb(CConfigManager.gs_globalConfig.gs_FormBackColor_R
                                                                          , CConfigManager.gs_globalConfig.gs_FormBackColor_G
                                                                          , CConfigManager.gs_globalConfig.gs_FormBackColor_B);
        /// <summary>
        /// 
        /// </summary>
        /// <param name="CNName"></param>
        /// <param name="ENName"></param>
        /// <param name="Permission"></param>
        /// <param name="ID"></param>
        /// <param name="PermissionLevel"></param>
        /// <returns></returns>
        public static string AuditPermission(string CNName, string ENName, string Permission,  int PermissionLevel)
        {
            string cryptStr = "";
            MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();

            string strMsg = "";
            int length = 0;
            if (CNName != "")
            {
                length = CNName.Length;
                length = length - length / 2;
                strMsg += CNName.Substring(length); ;
            }
            if (ENName != "")
            {
                length = ENName.Length;
                length = length - length / 3;
                strMsg += ENName.Substring(length);
            }

            if (Permission != "")
            {
                length = Permission.Length;
                length = length - length / 2;
                strMsg += Permission.Substring(length);
            }

            strMsg += PermissionLevel.ToString();

            byte[] bytes = Encoding.UTF8.GetBytes(strMsg);

            byte[] cryptBytes = md5.ComputeHash(bytes);
            for (int i = 0; i < cryptBytes.Length; i++)
            {
                cryptStr += cryptBytes[i].ToString("X2");
            }
            return cryptStr;
        }

        /// <summary>
        /// md5加密
        /// </summary>
        /// <param name="CNName"></param>
        /// <param name="ENName"></param>
        /// <param name="Permission"></param>
        /// <param name="ID"></param>
        /// <param name="PermissionLevel"></param>
        /// <returns></returns>
        public static string AuditUserPwd(string UserID, string Passwd, string Permission, DateTime StartTime, DateTime EndTime)
        {
            string strStartTime = StartTime.ToString("yyyy-MM-dd hh:mm:ss");
            string strEndTime = EndTime.ToString("yyyy-MM-dd hh:mm:ss");
            string cryptStr = "";
            MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();


            string strMsg = "";
            int length = 0;
            if (UserID != "")
            {
                strMsg += UserID;
            }
            if (Passwd != "")
            {
                strMsg += Passwd;
            }

            if (Permission != "")
            {
                strMsg += Permission.Substring(length);
            }

            if (strStartTime != "")
            {
                //length = strStartTime.Length;
                //length = length - length / 3;
                strMsg += strStartTime.Substring(length);
            }

            if (strEndTime != "")
            {
                //length = strEndTime.Length;
                //length = length - length / 3;
                strMsg += strEndTime.Substring(length);
            }
            byte[] bytes = Encoding.UTF8.GetBytes(strMsg);

            byte[] cryptBytes = md5.ComputeHash(bytes);
            for (int i = 0; i < cryptBytes.Length; i++)
            {
                cryptStr += cryptBytes[i].ToString("X2");
            }
            return cryptStr;
        }

        public static void GroupBoxReadModel(GroupBox model, int PermissionLevel)
        {
            if (PermissionLevel != (int)EPermissionLevel.Read 
                && PermissionLevel != (int)EPermissionLevel.ReadWrite
                )
            {
                model.Enabled = false;
            }
            else
            {
                model.Enabled = true;
            }

        }

        public static void ButtonHelps(Button bt)
        {
            bt.Location = new Point(5,12);
        }
        public static void GroupBoxReadWriteModel(GroupBox model,int PermissionLevel)
        {
            if (PermissionLevel != (int)EPermissionLevel.ReadWrite)
            {
                model.Enabled = false;
            }
            else
            {
                model.Enabled = true;
            }

        }

        public static void splitContainerModel(SplitContainer model)
        {
            model.SplitterDistance = model.Parent.Width * 2 / 3;
            model.FixedPanel = FixedPanel.Panel2;
            model.Panel2.AutoScroll = true;
            //model.
        }

        public static void DgvModel(DataGridView dgv)
        {
            dgv.ClearSelection();                                           //清除初始进入选项
            dgv.BackgroundColor = g_FormBackColor;

            dgv.SelectionMode = DataGridViewSelectionMode.FullRowSelect;    //设置为选全行           
            dgv.AllowUserToAddRows = false;
            dgv.AllowUserToDeleteRows = false;
            dgv.ForeColor = Color.Black;
            dgv.DefaultCellStyle.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleCenter;               //cell字体居中
            dgv.ColumnHeadersDefaultCellStyle.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleCenter;  //标括题琣字体居中
            dgv.ColumnHeadersDefaultCellStyle.WrapMode =  DataGridViewTriState.True;
            dgv.ScrollBars = ScrollBars.Both;

            //dgv.RowsDefaultCellStyle.SelectionBackColor = g_FormBackColor;

            #region 奇偶行颜色交替
            dgv.RowsDefaultCellStyle.BackColor = Color.White;
            dgv.AlternatingRowsDefaultCellStyle.BackColor = System.Drawing.Color.FromArgb(240, 240, 240);
            #endregion

            #region 设置dataGridView1的列标题的背景色和字体颜色
            DataGridViewCellStyle newStyle = new DataGridViewCellStyle();
            newStyle.ForeColor = Color.Black;
            newStyle.BackColor = System.Drawing.Color.FromArgb(240, 240, 240);
            foreach (DataGridViewColumn col in dgv.Columns)
            {
                col.HeaderCell.Style = newStyle;
                col.SortMode = DataGridViewColumnSortMode.Programmatic;
            }
            dgv.EnableHeadersVisualStyles = false;

            dgv.AllowUserToResizeRows = false;
            dgv.AllowUserToDeleteRows = false;
            dgv.AllowUserToAddRows = false;
            dgv.RowHeadersVisible = false;
            dgv.MultiSelect = false;
            dgv.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;
            dgv.ReadOnly = true;
            //dgv.BackgroundColor = Color.Transparent;
            #endregion
        }
    }
}
