﻿using CasunCommon.BaseUI;
using PMSUI.UI.平板任务删除;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Serialization;

namespace PMSUI
{
    public partial class MainForm : Form
    {
        //private string m_Permission = "";
        private string m_UserID = "";
        private string m_UserName = "";
        private string m_Permission = "";

        private Dictionary<string, PmsCoreDB.Model.PMS_sys_PermissionSetting> m_DicPermissionSet
    = new Dictionary<string, PmsCoreDB.Model.PMS_sys_PermissionSetting>();

        private Dictionary<string, string> _MenuNameDic = new Dictionary<string, string>();

        private CWarehouseTypeForm m_CWarehouseTypeForm;
        private CWMSSettingForm m_CWMSSettingForm;
        private CMenuSettingForm m_MenuSettingForm;
        private HistoryDataForm m_HistoryDataForm;
        private DisplayLanguageForm m_DisplayLanguageForm;
        private DisplaySettingForm m_DisplaySettingForm;
        private CStationIDRelatedForm m_CStationIDRelatedForm;
        private CSystemResetForm m_CSystemResetForm;
        private UserSettingForm m_UserSettingForm;
        private PermissionSettingForm m_PermissionSettingForm;
        private CBookTemplateForm m_CTaskTemplateForm;
        private CStepTemplateForm m_CStepTemplateForm;
        private CTaskExceptionHandling m_CTaskExceptionHandling;
        private CBehaviorForm m_BehaviorForm;
        private FrmDeletePadTask m_FrmDeletePadTask;

        private static MainForm m_Instance;           // 该类实例对象
        private int m_nNoSignalTime = 0;
        private ToolStripStatusLabel Time = new ToolStripStatusLabel();
        private ToolStripStatusLabel InfoLable = new ToolStripStatusLabel();
        private ToolStripStatusLabel OptTimeCheck = new ToolStripStatusLabel();

        private bool LoadPermissionFlag = false;
        public string Permission
        {
            get
            {
                return m_Permission;
            }
            set
            {
                m_Permission = value;
            }
        }
        public string UserID
        {
            get
            {
                return m_UserID;
            }
            set
            {
                m_UserID = value;
            }
        }
        public string UserName
        {
            get
            {
                return m_UserName;
            }
            set
            {
                m_UserName = value;
            }
        }

        public static MainForm Instance
        {
            get
            {
                //if(m_Instance == null)
                //{
                //    m_Instance = new SettingForm();
                //}
                return m_Instance;
            }
        }

        public MainForm(string UserID,string UserName,string Permission)
        {
            InitializeComponent();
            m_UserID = UserID;
            m_UserName = UserName;
            m_Permission = Permission;
            if (InitPermission())
            {
                LoadPermissionFlag = true;
            }
            LoadMenuSetting();
            CLanguageManager.SetLang(this);
            m_Instance = this;
        }

        private void Init()
        {
            InitColor();

            ToolStripStatusLabel Tss;
            Tss = new ToolStripStatusLabel();
            Tss.BackColor = CasunUILib.g_FormBackColor;
            Tss.Text ="ID：" + m_UserID;
            statusStrip1.Items.Add(Tss);

            Tss = new ToolStripStatusLabel();
            Tss.BorderSides = ToolStripStatusLabelBorderSides.Left;
            Tss.BackColor = CasunUILib.g_FormBackColor;
            Tss.Text = CLanguageManager.LanguageChange("用户名") + "：" + m_UserName;
            statusStrip1.Items.Add(Tss);

            //Tss = new ToolStripStatusLabel();
            //Tss.BorderSides = ToolStripStatusLabelBorderSides.Left;
            //Tss.BackColor = CasunUILib.g_FormBackColor;
            //Tss.Text = "权限：" + m_Permission;
            //statusStrip1.Items.Add(Tss);

            if (!LoadPermissionFlag)
            {
                Tss.ForeColor = Color.Red;
                Tss.Text = CLanguageManager.LanguageChange("初始化权限失败");
            }
            InfoLable.BackColor = CasunUILib.g_FormBackColor;
            InfoLable.Spring = true;
            statusStrip1.Items.Add(InfoLable);

            Time.BackColor = CasunUILib.g_FormBackColor;
            Time.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            Time.BorderSides = ToolStripStatusLabelBorderSides.Left;
            Time.Click += new EventHandler(Time_Click);

            statusStrip1.Items.Add(Time);

            OptTimeCheck.BackColor = CasunUILib.g_FormBackColor;
            OptTimeCheck.Text = "";
            OptTimeCheck.BorderSides = ToolStripStatusLabelBorderSides.Left;
            statusStrip1.Items.Add(OptTimeCheck);

            timer1.Enabled = true;
            timer1.Interval = 500;

            timer_CheckForm.Enabled = true;
            timer_CheckForm.Interval = 1000;
        }

        private bool InitPermission()
        {
            string strWhere = " Permission = '" + m_Permission + "'";
            List<PmsCoreDB.Model.PMS_sys_PermissionSetting> PermissionSetList
                = PmsCoreDB.DBHost.Instance.PermissionSetting.GetModelList(strWhere);

            if (PermissionSetList != null && PermissionSetList.Count > 0)
            {
                foreach (PmsCoreDB.Model.PMS_sys_PermissionSetting smodel in PermissionSetList)
                {
                    if (!m_DicPermissionSet.ContainsKey(smodel.CNFormName))
                    {
                        m_DicPermissionSet.Add(smodel.CNFormName, smodel);
                    }
                }
                return true;
            }
            else
            {
                return false;
            }
        }
        private void InitColor()
        {
            int a = CasunUILib.g_FormBackColor.A;
            int r = CasunUILib.g_FormBackColor.R + 122 > 255 ? CasunUILib.g_FormBackColor.R - 122 : CasunUILib.g_FormBackColor.R + 122;
            int g = CasunUILib.g_FormBackColor.G + 122 > 255 ? CasunUILib.g_FormBackColor.G - 122 : CasunUILib.g_FormBackColor.G + 122;
            int b = CasunUILib.g_FormBackColor.B + 122 > 255 ? CasunUILib.g_FormBackColor.B - 122 : CasunUILib.g_FormBackColor.B + 122;

            //int a = CasunUILib.g_FormBackColor.A;
            //int r = 255 - CasunUILib.g_FormBackColor.R;
            //int g = 255 - CasunUILib.g_FormBackColor.G;
            //int b = 255 - CasunUILib.g_FormBackColor.B;

            treeViewEx1.SelectColor = Color.LightBlue;
            treeViewEx1.SelectColor2 = Color.LightBlue;
            treeViewEx1.ColorEx = Color.LightBlue;

            //treeViewEx1.SelectColor = Color.FromArgb(a, r, g, b);
            //treeViewEx1.SelectColor2 = Color.FromArgb(a, r - 30 > 0 ? r - 30 : r, g - 30 > 0 ? g - 30 : g, b - 30 > 0 ? b - 30 : b);
            //treeViewEx1.ColorEx = Color.FromArgb(a, r - 60 > 0 ? r - 60 : r, g - 60 > 0 ? g - 60 : g, b - 60 > 0 ? b - 60 : b);

            treeViewEx1.BackColor = Color.FromArgb(CasunUILib.g_FormBackColor.R, CasunUILib.g_FormBackColor.G, CasunUILib.g_FormBackColor.B);
            statusStrip1.BackColor = Color.FromArgb(100, CasunUILib.g_FormBackColor.R, CasunUILib.g_FormBackColor.G, CasunUILib.g_FormBackColor.B);

            foreach (ToolStripStatusLabel con in statusStrip1.Items)
            {
                con.BackColor = CasunUILib.g_FormBackColor;
            }
        }

        /// <summary>
        /// 更新背景色
        /// </summary>
        public void BackColorChangeHandle()
        {
            InitColor();
        }

        private void SettingForm_Load(object sender, EventArgs e)
        {
            Init();
            PromptForm.OpenAction += OpenSettingForm;
        }
        
        private void LoadMenuSetting()
        {
            //清空
            treeViewEx1.Nodes.Clear();
            menuStrip1.Items.Clear();

            #region 获取数据
            List<PmsCoreDB.Model.PMS_sys_MenuSetting> smodelList = PmsCoreDB.DBHost.Instance.MenuSetting.GetModelList("1=1 order by ParentMenuSort,ChildMenuSort");
            Dictionary<string, Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>> MenuDic = new Dictionary<string, Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>>();

            foreach (PmsCoreDB.Model.PMS_sys_MenuSetting model in smodelList)
            {
                if (!model.IsShow)
                {
                    continue;
                }

                if(!CLoginForm.Instance.IsBuiltUser)
                {
                    if (!m_DicPermissionSet.ContainsKey(model.MenuName))
                    {            
                        continue;
                    }
                    else
                    {
                        if(m_DicPermissionSet[model.MenuName].PermissionLevel <= (int)EPermissionLevel.NoPower)
                        {
                            continue;
                        }
                    }
                }

                if (!MenuDic.ContainsKey(model.ModuleName))
                {
                    Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>  newModuleDic = new Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>();

                    newModuleDic.Add(model.MenuName, model);
                    MenuDic.Add(model.ModuleName, newModuleDic);
                }
                else
                {
                    if (!MenuDic[model.ModuleName].ContainsKey(model.MenuName))
                    {
                        MenuDic[model.ModuleName].Add(model.MenuName, model);
                    }
                }

                if(!_MenuNameDic.ContainsKey(model.MenuName))
                {
                    _MenuNameDic.Add(model.MenuName,model.DisplayMenuName);
                }
            }
            #endregion
            #region 左边树菜单
            foreach (KeyValuePair<string, Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>> pair in MenuDic)
            {
                //加根节点
                if (!treeViewEx1.Nodes.ContainsKey(pair.Key))
                {
                    TreeNode blankNode = new TreeNode();
                    TreeNode parentNode = new TreeNode(pair.Key);
                    parentNode.Text = pair.Key;
                    parentNode.Name = pair.Key;
                    parentNode.ImageIndex = 1;
                    parentNode.SelectedImageIndex = 1;
                    treeViewEx1.Nodes.Add(blankNode);
                    treeViewEx1.Nodes.Add(parentNode);
                }

                //子节点
                foreach (PmsCoreDB.Model.PMS_sys_MenuSetting item in pair.Value.Values)
                {
                    TreeNode node = new TreeNode(item.MenuName);
                    node.Text = item.DisplayMenuName;
                    node.Name = item.MenuName;
                    node.ImageIndex = 1;
                    node.SelectedImageIndex = 1;

                    foreach (TreeNode parentNode in treeViewEx1.Nodes)
                    {
                        if (parentNode.Text == item.ModuleName)
                        {
                            parentNode.Nodes.Add(node);
                        }
                    }
                }
            }
            #endregion
            #region 上面菜单
            foreach (KeyValuePair<string, Dictionary<string, PmsCoreDB.Model.PMS_sys_MenuSetting>> pair in MenuDic)
            {
                //加根节点
                if (!menuStrip1.Items.ContainsKey(pair.Key))
                {
                    ToolStripMenuItem parentItem = new ToolStripMenuItem();
                    parentItem.Text = pair.Key;
                    menuStrip1.Items.Add(parentItem);
                }

                //子节点
                foreach (PmsCoreDB.Model.PMS_sys_MenuSetting item in pair.Value.Values)
                {
                    ToolStripMenuItem childItem = new ToolStripMenuItem();
                    childItem.Text = item.DisplayMenuName;
                    childItem.Name = item.MenuName;
                    childItem.Click += new EventHandler(toolStripMenuItem_Click);
                    
                                       
                    foreach (ToolStripMenuItem parentItem in menuStrip1.Items)
                    {
                        if (parentItem.Text == item.ModuleName)
                        {
                            parentItem.DropDownItems.Add(childItem);
                        }
                    }
                }
            }
            #endregion
        }

        private void Time_Click(object sender, EventArgs e)
        {
            ToolStripStatusLabel item = sender as ToolStripStatusLabel;
            if (item != null)
            {
                PromptForm form = new PromptForm();
                //form.Show();
                form.ShowDialog();
            }
        }

        private void SettingForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            m_Instance = null;
            PromptForm.OpenAction -= OpenSettingForm;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Time.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            OptTimeCheck.Text = CLanguageManager.LanguageChange("离线时间") +  "：" + m_nNoSignalTime.ToString() + "S";
        }

        #region 界面共性设置
        private void Form_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form sform = sender as Form;
            foreach (TabPage tp in tabControl1.TabPages)
            {
                if (tp.Name == sform.Name)
                {
                    tabControl1.TabPages.Remove(tp);
                }
            }
        }

        /// <summary>
        /// 新建一个 TabPage
        /// </summary>
        /// <param name="frm"></param>
        private void NewTabpage(CasunForm frm,string FormName)
        {
            int PermissionLevel = 0;
            if(CLoginForm.Instance.IsBuiltUser)
            {
                PermissionLevel = (int)EPermissionLevel.ReadWrite;
            }
            else
            {
                if (!CheckFormPerimission(FormName, out PermissionLevel))
                {
                    frm = null;
                    return;
                }
            }

            if (frm == null)
            {
                return;
            }
            frm.TopLevel = false;
            frm.WindowState = FormWindowState.Normal;
            frm.Dock = DockStyle.Fill;
            frm.FormBorderStyle = FormBorderStyle.None;
            frm.BackColor = CasunUILib.g_FormBackColor;
            frm.PermissionLevel = PermissionLevel;
            frm.UserID = m_UserID;
            frm.Name = FormName;

            if (_MenuNameDic.ContainsKey(FormName))
            {
                frm.Text = CLanguageManager.LanguageChange(_MenuNameDic[FormName]) ;
            }
            else
            {
                frm.Text = CLanguageManager.LanguageChange(frm.Name) ;
            }
            CLanguageManager.SetLang(frm);

            TabPage Ta = new TabPage();
            Ta.Name = frm.Name;
            Ta.Text = frm.Text;


            Ta.Controls.Add(frm);
            //Ta.AutoScroll = true;
            Ta.ToolTipText = "Double click close";
            tabControl1.TabPages.Add(Ta);
            frm.FormClosed += Form_FormClosed;

            frm.Width = Ta.Width;
            frm.Show();
            tabControl1.SelectedTab = Ta;
        }

        /// <summary>
        /// 新建一个 TabPage
        /// </summary>
        /// <param name="frm"></param>
        private void NewTabpage1(CasunForm frm,int PermissionLevel)
        {
            if(frm == null)
            {
                return;
            }
            frm.TopLevel = false;
            frm.WindowState = FormWindowState.Normal;
            frm.Dock = DockStyle.Fill;
            frm.FormBorderStyle = FormBorderStyle.None;
            frm.BackColor = CasunUILib.g_FormBackColor;
            frm.PermissionLevel = PermissionLevel;
            frm.UserID = m_UserID;

            TabPage Ta = new TabPage();
            Ta.Name = frm.Name;
            Ta.Text = frm.Text;
            Ta.Controls.Add(frm);
            //Ta.AutoScroll = true;
            Ta.ToolTipText = "Double click close";
            tabControl1.TabPages.Add(Ta);
            frm.FormClosed += Form_FormClosed;

            frm.Width = Ta.Width;
            frm.Show();
            tabControl1.SelectedTab = Ta;
        }

        /// <summary>
        /// 显示一个 TabPage
        /// </summary>
        /// <param name="frm"></param>
        private void ShowTabpage(Form frm)
        {
            frm.BackColor = CasunUILib.g_FormBackColor;
            tabControl1.SelectedTab = (TabPage)frm.Parent;
        }


        private void tabControl1_MouseClick(object sender, MouseEventArgs e)
        {
            TabControl tab = sender as TabControl;
            Form sForm = tab.SelectedTab.Controls[0] as Form;
            sForm.BackColor = CasunUILib.g_FormBackColor;
        }

        private void tabControl1_MouseDoubleClick(object sender, MouseEventArgs e)
        {

            TabControl tab = sender as TabControl;
            Form sForm = tab.SelectedTab.Controls[0] as Form;
            sForm.Close();
        }
        #endregion
        #region 打开Form方法
        private void OnBehaviorFormCheck(string FormName)
        {
            if (m_BehaviorForm == null)
            {
                m_BehaviorForm = new CBehaviorForm();
                NewTabpage(m_BehaviorForm, FormName);
            }
            else if (m_BehaviorForm.IsDisposed)
            {
                m_BehaviorForm = new CBehaviorForm();
                NewTabpage(m_BehaviorForm, FormName);
            }
            else
            {
                ShowTabpage(m_BehaviorForm);
            }
        }

        private void OnCTaskTemplateFormCheck(string FormName)
        {
            if (m_CTaskTemplateForm == null)
            {
                m_CTaskTemplateForm = new CBookTemplateForm();
                NewTabpage(m_CTaskTemplateForm, FormName);
            }
            else if (m_CTaskTemplateForm.IsDisposed)
            {
                m_CTaskTemplateForm = new CBookTemplateForm();
                NewTabpage(m_CTaskTemplateForm, FormName);
            }
            else
            {
                ShowTabpage(m_CTaskTemplateForm);
            }
        }


        private void OnWMSSettingCheck(string FormName)
        {
            if (m_CWMSSettingForm == null)
            {
                m_CWMSSettingForm = new CWMSSettingForm();
                NewTabpage(m_CWMSSettingForm, FormName);
            }
            else if (m_CWMSSettingForm.IsDisposed)
            {
                m_CWMSSettingForm = new CWMSSettingForm();
                NewTabpage(m_CWMSSettingForm, FormName);
            }
            else
            {
                ShowTabpage(m_CWMSSettingForm);
            }
        }
        private void OnCStepTemplateFormCheck(string FormName)
        {
            if (m_CStepTemplateForm == null)
            {
                m_CStepTemplateForm = new CStepTemplateForm();
                NewTabpage(m_CStepTemplateForm, FormName);
            }
            else if (m_CStepTemplateForm.IsDisposed)
            {
                m_CStepTemplateForm = new CStepTemplateForm();
                NewTabpage(m_CStepTemplateForm, FormName);
            }
            else
            {
                ShowTabpage(m_CStepTemplateForm);
            }
        }
        private void OnFrmDeletePadTask(string FormName)
        {
            if (m_FrmDeletePadTask == null)
            {
                m_FrmDeletePadTask = new FrmDeletePadTask();
                NewTabpage(m_FrmDeletePadTask, FormName);
            }
            else if (m_FrmDeletePadTask.IsDisposed)
            {
                m_FrmDeletePadTask = new FrmDeletePadTask();
                NewTabpage(m_FrmDeletePadTask, FormName);
            }
            else
            {
                ShowTabpage(m_FrmDeletePadTask);
            }
        }
        private void OnCTaskExceptionHandlingCheck(string FormName)
        {
            if (m_CTaskExceptionHandling == null)
            {
                m_CTaskExceptionHandling = new CTaskExceptionHandling();
                NewTabpage(m_CTaskExceptionHandling, FormName);
            }
            else if (m_CTaskExceptionHandling.IsDisposed)
            {
                m_CTaskExceptionHandling = new CTaskExceptionHandling();
                NewTabpage(m_CTaskExceptionHandling, FormName);
            }
            else
            {
                ShowTabpage(m_CTaskExceptionHandling);
            }
        }

        private void OnWarehouseTypeCheck(string FormName)
        {
            if (m_CWarehouseTypeForm == null)
            {
                m_CWarehouseTypeForm = new CWarehouseTypeForm();
                NewTabpage(m_CWarehouseTypeForm, FormName);
            }
            else if (m_CWarehouseTypeForm.IsDisposed)
            {
                m_CWarehouseTypeForm = new CWarehouseTypeForm();
                NewTabpage(m_CWarehouseTypeForm, FormName);
            }
            else
            {
                ShowTabpage(m_CWarehouseTypeForm);
            }
        }
        private void OnHistoryDataCheck(string FormName)
        {
            if (m_HistoryDataForm == null)
            {
                m_HistoryDataForm = new HistoryDataForm();
                NewTabpage(m_HistoryDataForm, FormName);
            }
            else if (m_HistoryDataForm.IsDisposed)
            {
                m_HistoryDataForm = new HistoryDataForm();
                NewTabpage(m_HistoryDataForm, FormName);
            }
            else
            {
                ShowTabpage(m_HistoryDataForm);
            }
        }

        private void OnDisPlayLanguageCheck(string FormName)
        {
            if (m_DisplayLanguageForm == null)
            {
                m_DisplayLanguageForm = new DisplayLanguageForm();
                NewTabpage(m_DisplayLanguageForm, FormName);
            }
            else if (m_DisplayLanguageForm.IsDisposed)
            {
                m_DisplayLanguageForm = new DisplayLanguageForm();
                NewTabpage(m_DisplayLanguageForm, FormName);
            }
            else
            {
                ShowTabpage(m_DisplayLanguageForm);
            }
        }

        private void OnUserSettingFormCheck(string FormName)
        {
            if (m_UserSettingForm == null)
            {
                m_UserSettingForm = new UserSettingForm();
                NewTabpage(m_UserSettingForm, FormName);
            }
            else if (m_UserSettingForm.IsDisposed)
            {
                m_UserSettingForm = new UserSettingForm();
                NewTabpage(m_UserSettingForm, FormName);
            }
            else
            {
                ShowTabpage(m_UserSettingForm);
            }
        }

        private void OnPermissionSettingFormCheck(string FormName)
        {
            if (m_PermissionSettingForm == null)
            {
                m_PermissionSettingForm = new PermissionSettingForm();
                NewTabpage(m_PermissionSettingForm, FormName);
            }
            else if (m_PermissionSettingForm.IsDisposed)
            {
                m_PermissionSettingForm = new PermissionSettingForm();
                NewTabpage(m_PermissionSettingForm, FormName);
            }
            else
            {
                ShowTabpage(m_PermissionSettingForm);
            }
        }
        private void OnDisplaySettingFormCheck(string FormName)
        {
            if (m_DisplaySettingForm == null)
            {
                m_DisplaySettingForm = new DisplaySettingForm();
                NewTabpage(m_DisplaySettingForm, FormName);
            }
            else if (m_DisplaySettingForm.IsDisposed)
            {
                m_DisplaySettingForm = new DisplaySettingForm();
                NewTabpage(m_DisplaySettingForm, FormName);
            }
            else
            {
                ShowTabpage(m_DisplaySettingForm);
            }
        }

        private void OnCSystemResetFormCheck(string FormName)
        {
            if (m_CSystemResetForm == null)
            {
                m_CSystemResetForm = new CSystemResetForm();
                NewTabpage(m_CSystemResetForm, FormName);
            }
            else if (m_CSystemResetForm.IsDisposed)
            {
                m_CSystemResetForm = new CSystemResetForm();
                NewTabpage(m_CSystemResetForm, FormName);
            }
            else
            {
                ShowTabpage(m_CSystemResetForm);
            }
        }
        private void OnCStationIDRelatedFormCheck(string FormName)
        {
            if (m_CStationIDRelatedForm == null)
            {
                m_CStationIDRelatedForm = new CStationIDRelatedForm();
                NewTabpage(m_CStationIDRelatedForm, FormName);
            }
            else if (m_CStationIDRelatedForm.IsDisposed)
            {
                m_CStationIDRelatedForm = new CStationIDRelatedForm();
                NewTabpage(m_CStationIDRelatedForm, FormName);
            }
            else
            {
                ShowTabpage(m_CStationIDRelatedForm);
            }
        }
   
        void OpenSettingForm(int eve)
        {
            if (m_MenuSettingForm == null)
            {
                m_MenuSettingForm = new CMenuSettingForm();
                NewTabpage(m_MenuSettingForm, CasunUILib.EForms.MenuSetting.ToString());
            }
            else if (m_MenuSettingForm.IsDisposed)
            {
                m_MenuSettingForm = new CMenuSettingForm();
                NewTabpage(m_MenuSettingForm, CasunUILib.EForms.MenuSetting.ToString());
            }
            else
            {
                ShowTabpage(m_MenuSettingForm);
            }
        }
        #endregion

        private void timer_CheckForm_Tick(object sender, EventArgs e)
        {
            //m_nNoSignalTime += 1;
            //// 大于10分钟 无操作 界面退出
            //// 优化 根据用户权限不同设置不同的超时时间 权限越高 超时越短
            //if (m_nNoSignalTime > 300)
            //{
            //    this.Close();
            //}
        }

        private void treeViewEx1_AfterExpand(object sender, TreeViewEventArgs e)
        {
            TreeNode tn = e.Node;
            if (tn.Parent != null)
            {
                foreach (TreeNode node in tn.Parent.Nodes)
                {
                    if (tn != node)
                    {
                        node.Collapse();
                    }
                }
            }
            while (tn.Parent != null)
                tn = tn.Parent;

            foreach (TreeNode node in treeViewEx1.Nodes)
            {
                if (tn != node)
                {
                    node.Collapse();
                }
            }
        }
        private void toolStripMenuItem_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem item = sender as ToolStripMenuItem;
            if (item != null)
            {
                OpenForm(item.Name);
            }
        }

        private void treeViewEx1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            OpenForm(e.Node.Name);
        }

        private void FormOpt(string ItemName, bool IsOpenForm)
        {
            CasunUILib.EForms EItem;
            if (!Enum.TryParse(ItemName, out EItem))
            {
                return;
            }

            switch (EItem)
            {
                case CasunUILib.EForms.WarehouseSetting:
                    if (IsOpenForm) OnWMSSettingCheck(ItemName); else  m_CWarehouseTypeForm.Close();
                    break;
                case CasunUILib.EForms.WarehouseTypeSetting:
                    if (IsOpenForm) OnWarehouseTypeCheck(ItemName); else m_CWarehouseTypeForm.Close();
                    break;
                case CasunUILib.EForms.HistoryOrderDataQuery:
                    if (IsOpenForm) OnHistoryDataCheck(ItemName); else m_HistoryDataForm.Close();
                    break;
                case CasunUILib.EForms.LanguageSetting:
                    if (IsOpenForm) OnDisPlayLanguageCheck(ItemName); else m_DisplayLanguageForm.Close();
                    break;
                case CasunUILib.EForms.DisplaySetting:
                    if (IsOpenForm) OnDisplaySettingFormCheck(ItemName); else m_DisplaySettingForm.Close();
                    break;
                case CasunUILib.EForms.StationIDRelateSetting:
                    if (IsOpenForm) OnCStationIDRelatedFormCheck(ItemName); else m_CStationIDRelatedForm.Close();
                    break;
                case CasunUILib.EForms.SystemReset:
                    if (IsOpenForm) OnCSystemResetFormCheck(ItemName); else m_CSystemResetForm.Close();
                    break;
                case CasunUILib.EForms.UserSetting:
                    if (IsOpenForm) OnUserSettingFormCheck(ItemName); else m_UserSettingForm.Close();
                    break;
                case CasunUILib.EForms.PermissionSetting:
                    if (IsOpenForm) OnPermissionSettingFormCheck(ItemName); else m_PermissionSettingForm.Close();
                    break;
                case CasunUILib.EForms.TaskBookTemplateSetting:
                    if (IsOpenForm) OnCTaskTemplateFormCheck(ItemName); else m_CTaskTemplateForm.Close();
                    break;
                case CasunUILib.EForms.OrderExceptionHandling:
                    if (IsOpenForm) OnCTaskExceptionHandlingCheck(ItemName); else m_CTaskExceptionHandling.Close();
                    break;
                case CasunUILib.EForms.StepBookTemplateSetting:
                    if (IsOpenForm) OnCStepTemplateFormCheck(ItemName); else m_CStepTemplateForm.Close();
                    break;
                case CasunUILib.EForms.BehaviorSetting:
                    if (IsOpenForm) OnBehaviorFormCheck(ItemName); else m_BehaviorForm.Close();
                    break;
                case CasunUILib.EForms.FrmDeletePadTask:
                    if (IsOpenForm) OnFrmDeletePadTask(ItemName); else m_FrmDeletePadTask.Close();
                    break;
                default:
                    break;
            }
        }
        private void CloseForm(string ItemName)
        {
            FormOpt(ItemName, false);
        }
        private void OpenForm(string ItemName)
        {
            FormOpt(ItemName, true);
        }

        #region 权限控制
        private bool CheckFormPerimission(string FormName, out int PermissionLevel)
        {
            PermissionLevel = 0;
            if (m_DicPermissionSet.ContainsKey(FormName))
            {
                PermissionLevel = m_DicPermissionSet[FormName].PermissionLevel;
                
                if (m_DicPermissionSet[FormName].AuditPermissionLevel !=
                    PMSUI.CasunUILib.AuditPermission(
                        m_DicPermissionSet[FormName].CNFormName,
                        "",
                        m_DicPermissionSet[FormName].Permission,
                        m_DicPermissionSet[FormName].PermissionLevel
                        ))
                {
                    InfoLable.ForeColor = Color.Red;
                    InfoLable.Text = "界面权限非法改动，不能进入！";
                    return false;
                }
                else
                {
                    InfoLable.Text = "";
                }

                if (PermissionLevel == (int)EPermissionLevel.NoPower)
                {
                    InfoLable.ForeColor = Color.Red;
                    InfoLable.Text = "无界面权限，不能进入！";
                    return false;
                }
                else
                {
                    return true;
                }
            }
            else
            {
                PermissionLevel = (int)EPermissionLevel.NoPower;

                InfoLable.ForeColor = Color.Red;
                InfoLable.Text = "界面权限未设定，不能进入！";
                return false;
            }
        }
        #endregion
    }
}
