﻿using Pms.InternalInterface.Controllers;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Models;
using Pms.UserEvent.SystemEvent;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pms.UserEvent
{
    public class CPmsControllers
    {
        private static CPmsControllers m_instance = new CPmsControllers();
        public static CPmsControllers Instance { get { return m_instance; } }


        private CMidOrderController _MidOrderController;
        private CCarrierController _CarrierController;
        private CMapController _MapController;
        private COrderDataController _OrderDataController;
        private CSystemController _SystemController;
        private CTaskBookController _TaskBookController;
        private CTaskMaterialController _TaskMaterialController;
        private CStepBookController _StepBookController;
        private CWarehouseController _WarehouseController;

        public CMidOrderController MidOrderController { get { return _MidOrderController; } }
        public CCarrierController CarrierController { get { return _CarrierController; } }
        public CMapController MapController { get { return _MapController; } }
        public COrderDataController OrderDataController { get { return _OrderDataController; } }
        public CSystemController SystemController { get { return _SystemController; } }
        public CTaskBookController TaskBookController { get { return _TaskBookController; } }
        public CTaskMaterialController TaskMaterialController { get { return _TaskMaterialController; } }
        public CStepBookController StepBookController { get { return _StepBookController; } }
        public CWarehouseController WarehouseController { get { return _WarehouseController; } }

        private CPmsControllers()
        {
            InitControllers();
        }

        public void InitControllers()
        {
            _MidOrderController = new CMidOrderController();
            _CarrierController = new CCarrierController();
            _MapController = new CMapController();
            _OrderDataController = new COrderDataController();
            _SystemController = new CSystemController();
            _TaskBookController = new CTaskBookController();
            _TaskMaterialController = new CTaskMaterialController();
            _StepBookController = new CStepBookController();
            _WarehouseController = new CWarehouseController();

        }

        public bool UpDateMidDataState(string OrderID, EMidOrderState Estate)
        {
            MidOrderData MidOrder;
            EFailCode failcode;
            if (_MidOrderController.GetModel(OrderID, out MidOrder, out failcode))
            {
                MidOrder.State = Estate.ToString();

                if (_MidOrderController.UpDate(MidOrder, out failcode))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
    }
}
