﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pms.UserEvent.CenterManageSystemModel
{
    public class CMaterial
    {
        public string m_time;
        public string m_callStation;//站点名称
        public string m_materialName;//物料名称
        public string m_maNum;//物料数量
        public int m_route;//AGV运送路线
        public int m_agvID;//AGVID
        public string m_status;//状态 
        public int m_padID;//PadID
        public int m_callID;//
        public int m_callStationToPos;//叫料站点对应的地标
        public int mark;//地标

        public CMaterial()
        {
            m_time = DateTime.Now.ToShortTimeString();
            m_callStation = "";
            m_maNum = "0";
            m_materialName = "";
            m_route = 0;
            m_agvID = 0;
            m_status = "等待";
            m_padID = 0;
            m_callID = 0;
            m_callStationToPos = 0;
            mark = 0;
        }
    }

    public class CData
    {
        public int ID;
        public string stationName;
        public string maName;
        public string maNum;
        public int stationPos;

        /// <summary>
        /// 用于存储物料清单的Excel表格信息
        /// </summary>
        public CData()
        {
            ID = 0;
            stationName = "";
            maName = "";
            maNum = "";
            stationPos = 0;
        }

        /// <summary>
        /// 根据ID，获得站点名称
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static string GetStationNameByID(int id)
        {
            string stationName = "";
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].ID == id)
                    stationName = Global.gs_data[i].stationName;
            }
            return stationName;
        }
        /// <summary>
        /// 根据ID，获得物料名称
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static string GetMaNameByID(int id)
        {
            string maName = "";
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].ID == id)
                    maName = Global.gs_data[i].maName;
            }
            return maName;
        }
        /// <summary>
        /// 根据ID，获得物料数量
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static string GetMaNumByID(int id)
        {
            string maNum = "";
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].ID == id)
                    maNum = Global.gs_data[i].maNum;
            }
            return maNum;
        }
        /// <summary>
        /// 根据ID，获得站点地标
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public static int GetStationPosByID(int id)
        {
            int stationPos = 0;
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].ID == id)
                    stationPos = Convert.ToInt32(Global.gs_data[i].stationPos);
            }
            return stationPos;
        }
        /// <summary>
        /// 判断一个点是否为下料点
        /// </summary>
        /// <param name="pos"></param>
        /// <returns></returns>
        public static bool IsExistPosInGs_data(int pos)
        {
            bool flag = false;
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].stationPos == pos)
                {
                    flag = true;
                    break;
                }
            }
            return flag;
        }
        /// <summary>
        /// 根据站点名称，获得地标
        /// </summary>
        /// <param name="stationName"></param>
        /// <returns></returns>
        public static int GetStationPosByStationName(string stationName)
        {
            int stationPos = 0;
            for (int i = 0; i < Global.gs_data.Count; i++)
            {
                if (Global.gs_data[i].stationName == stationName)
                    stationPos = Convert.ToInt32(Global.gs_data[i].stationPos);
            }
            return stationPos;
        }
    }
}
