﻿using CasunCommon.SystemLog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pms.UserEvent
{

    class SCL_DMS_WebServiceHelper
    {
        public static string addressWebsite = UriSetting.g_MESUri;//"http://127.0.0.1:8634/casunsystem/"
        static RestRequestHelper requestHelperForClient = new RestRequestHelper(addressWebsite);
       
       

        /// <summary>
        /// 对应接口编号002
        /// </summary>
        /// <returns></returns>
        public static ReportMaterialLocationResponse ReportTaskStatus(ReportTaskStatusRequest taskStatusRequest)
        {
            //{"code":200,"message":"返回成功"}
            string data = JsonHelper.ConvertToJson(typeof(ReportTaskStatusRequest), taskStatusRequest);
            string uri = "AGVRet";//api/OutService.IntelligentStorage.IntelligentForklift/
            CLog.Instance.WriteLog("上报到站", "请求:" + data);
            string strBeforeDecrypt = requestHelperForClient.PostWithWholeURI(data, UriSetting.g_MESUri + "/" + uri);
            CLog.Instance.WriteLog("上报到站", "返回:" + strBeforeDecrypt);
            ReportMaterialLocationResponse returnValue = (ReportMaterialLocationResponse)JsonHelper.ConvertToObject(typeof(ReportMaterialLocationResponse), strBeforeDecrypt);
            return returnValue;
        }

        /// <summary>
        /// 对应接口编号003
        /// </summary>
        /// <returns></returns>
        public static ReportMaterialLocationResponse ReportMaterialStation(ReportMaterialLocationRequest[] materialLocationRequest)
        {
            string data = JsonHelper.ConvertToJson(typeof(ReportMaterialLocationRequest[]), materialLocationRequest);
            CLog.Instance.WriteLog("上报物料位置", "请求:" + data);
            string uri = "SyncPalletPosition";
            string strBeforeDecrypt = requestHelperForClient.PostWithWholeURI(data, UriSetting.g_MESUri + "/" + uri);
            CLog.Instance.WriteLog("上报物料位置", "返回:" + strBeforeDecrypt);
            ReportMaterialLocationResponse returnValue = new ReportMaterialLocationResponse();
            return returnValue;
        }

        /// <summary>
        /// 对应接口编号004 获取库位(电梯)状态
        /// </summary>
        /// <returns></returns>
        public static GetStationStatusResponse GetStationStatus(string locationcode)
        {
            
            string uri = "AGVPositionState/"+ locationcode;
            CLog.Instance.WriteLog("获取电梯库位状态", "请求:" + UriSetting.g_MESUri + "/" + uri);
            string strBeforeDecrypt = requestHelperForClient.Get( UriSetting.g_MESUri + "/" + uri);
            CLog.Instance.WriteLog("获取电梯库位状态", "返回:" + strBeforeDecrypt);
            GetStationStatusResponse returnValue = (GetStationStatusResponse)JsonHelper.ConvertToObject(typeof(GetStationStatusResponse), strBeforeDecrypt);
            return returnValue;
        }
    }

    public class ReportTaskStatusRequest
    {
        public string TaskId = "";
        public string Status = "";//到站/离开/取消/卸料完成/取料完成
        public string StationId = "";
        public string MaterlalId = "";
        public string AGVId = "";
    }
    public class ReportTaskStatusResponse
    {
        public string resCode = "";
        public string resMsg = "";
    }

    //    {
    //"resCode":0,
    //"resMsg":"成功"，
    //MaterialList:{
    //{“PID1001”，“A1”}，
    //{“PID1001”，“A2”}，
    //{“PID1001”，A3}
    //}
    //}
    //public class ReportMaterialLocationRequest
    //{
    //    public string StationId = "";
    //    public string MaterlalId = "";
    //}
    public class ReportMaterialLocationRequest
    {
        public string boxno = "";
        public string cwdm = "";
        public string jlrq = "";
    }
    //public class ReportMaterialLocationCollectionRequest
    //{
    //    public string boxno = "";
    //    public string cwdm = "";
    //    public string jlrq = "";
    //}
    public class MaterialLocation
    {

    }

    public class ReportMaterialLocationResponse
    {
        public string resCode = "";
        public string resMsg = "";
    }

    public class GetStationStatusResponse
    {
        public bool succeeded = false;
        public string errors = "";
        public string message = "";
        public string data = "";
    }

}

