﻿using CasunCommon.SystemLog;
using IOTransmissionAbutment;
using Pms.EventLibrary.TaskEvent;
using Pms.EventLibrary.TaskEventArgs;
using Pms.InternalInterface.Controllers;
using Pms.UserEvent.CenterManageSystemModel;
using Pms.UserEvent.Model;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace Pms.UserEvent.StepBookEvent
{
    class UpMaterial_61001 : BaseStepBookEvent
    {
        public UpMaterial_61001() : base(61001) { }
        CSystemController _SystemController = new CSystemController();
        //SystemEvent.CSystemEvent cSystem = new SystemEvent.CSystemEvent();
        CCarrierController cCCarrierController = new CCarrierController();
        /// <summary>
        /// 创建 步骤簿时 处理此行为码时触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override void StepBookCreate(object sender, P_StepBookCreateEventArgs e)
        {
            //if (MessageBox.Show("是否创建成功！", "触发步骤创建事件", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) != DialogResult.OK)
            //{
            //    e.IsSuccess = false;
            //}
            //else
            //{
            //    e.IsSuccess = true;
            //}
        }

        /// <summary>
        /// 步骤簿 开始执行时触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override void StepBookStarted(object sender, P_StepBookExecuteEventArgs e)
        {
            //if (MessageBox.Show("是否开始成功！", "触发步骤开始事件", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) != DialogResult.OK)
            //{
            //    e.IsSuccessed = false;
            //}
            //else
            //{
            //    e.IsSuccessed = true;
            //}
        }

        /// <summary>
        /// 步骤簿 执行中 触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override void StepBookExecuting(object sender, P_StepBookExecuteEventArgs e)
        {
            //if (MessageBox.Show("是否执行成功！", "触发步骤执行中事件", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) != DialogResult.OK)
            //{
            //    e.IsSuccessed = false;
            //}
            //else
            //{
            //    e.IsSuccessed = true;
            //}
        }
        /// <summary>
        /// 步骤簿 执行结束触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override void StepBookEnd(object sender, P_StepBookExecuteEventArgs e)
        {
            try
            {
                IOTransmissionDevice device = DeviceManager.GetRollerDevice($"{e.TaskBook.WareHouse}");
                //device.SendCmd(device.ID);
                device.Carrier = e.TaskBook.Carrier;
                if (device != null && device.X1 && device.X3)
                {
                    //device.Y1 = true;
                    //device.Y2 = true;
                    //if (device.X2)
                    //{
                    e.IsSuccessed = true;
                    CLog.Instance.WriteLog("61001", $"OrderID:【{e.TaskBook.OrderID}】,库位{device.Name},device.X1:[上层允许动作]device.X3:[下层允许动作]");
                    //}
                    //else
                    //{
                    //    e.IsSuccessed = false;
                    //    CLog.Instance.WriteLog("注塑机:取空箱", $"OrderID:【{e.TaskBook.OrderID}】device.X2:[禁止]");
                    //}
                }
                else
                {
                    e.IsSuccessed = false;
                    CLog.Instance.WriteLog("61001", $"OrderID:【{e.TaskBook.OrderID}】,库位{device.Name},device.X1:[禁止]device.X3:[禁止]");
                }
            }
            catch (Exception ex)
            {
                CLog.Instance.WriteLog("61001_Error", $"OrderID:【{e.TaskBook.OrderID}】异常：【{ex.Message}】异常明细[{ex.StackTrace}]");
            }
        }
    }
}

