﻿using CasunCommon.SystemLog;
using Pms.EventLibrary.SystemEvent;
using Pms.UserEvent.CenterManageSystemModel;
using Pms.UserEvent.Model;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Xml.Serialization;
using System.Collections.Concurrent;
using System.Data;
using Pms.InternalInterface.Models;
using Pms.Common.SystemEnum;
using Pms.InternalInterface.Enums;
using Pms.InternalInterface.Controllers;
using PmsCoreDB;
using Pms.Interface;
using Pms.Interface.ResultModels;
using IOTransmissionAbutment;

namespace Pms.UserEvent.SystemEvent
{

    public class CSystemEvent
    {
        private Thread _TaskThread;
        private void LoadConfig()
        {
            XmlSerializer deserializer1 = new XmlSerializer(Global.gs_configInfo.GetType());
            try
            {
                using (TextReader tr = new StreamReader($"{ AppDomain.CurrentDomain.BaseDirectory}Plugins\\PMS\\Config\\CConfig.xml"))
                {
                    Global.gs_configInfo = (CConfigData)deserializer1.Deserialize(tr);
                }
            }
            catch (Exception ex)
            {
                CLog.Instance.WriteLog("配置文件解析", $"解析异常！{ex.Message}");
            }
        }
        public CSystemEvent()
        {
            LoadConfig();
            try
            {
                string sql = $"select * from IOTransmissionDevice";
                dt_IOT = ConDataBase_DJH.reDt(sql);//获取库位名称   

                string[] times = File.ReadAllLines($"{AppDomain.CurrentDomain.BaseDirectory}Plugins\\PMS\\Config\\DataSource_DJH.Config", Encoding.UTF8);
                if (times != null)
                {
                    //正式使用时恢复
                    DeviceManager.Init(times[0].ToString());
                }
                //正式使用时恢复
                DeviceManager.StartSend();
                //new Task(new Action(ScanCarriers)).Start();
                //StringBuilder updateStatus = new StringBuilder();
                //updateStatus.Clear();
                //updateStatus.Append($" update T_ErrorTable set _ErrorAlarmStartTime='1'");
                //int flags = ConDataBase_PMS.sqlNonQuery(updateStatus.ToString());
            }
            catch (Exception ex)
            {
                CLog.Instance.WriteLog("对接盒", $"异常：【{ex.Message}】");
            }
            CSystemEventHandler.Instance.SystemStarted += Instance_SystemStarted;
        }
        public static Dispatcher dispacher;

        CCarrierController cCCarrierController = new CCarrierController();
        /// <summary>
        /// 电梯信息
        /// </summary>
        public DataTable dt_IOT = new DataTable();
        /// <summary>
        /// 库位名称
        /// </summary>
        private static ConcurrentDictionary<string, string> StationName = new ConcurrentDictionary<string, string>();
        /// <summary>
        /// 叫料
        /// </summary>
        private static List<string> routeList = new List<string>();
        /// <summary>
        ///取消叫料
        /// </summary>
        private static List<CMaterial> materialCanceList = new List<CMaterial>();
        /// <summary>
        /// 订单管理器
        /// </summary>
        COrderDataController _OrderDataController = new COrderDataController();
        private static List<CMaterial> AGVReleasedList = new List<CMaterial>();
        public static Pms.InternalInterface.Controllers.CWarehouseController cWarehouseController = new CWarehouseController();
        private void Instance_SystemStarted(object sender, bool StartSuccess)
        {
            if (StartSuccess)
            {
                try
                {
                    List<Warehouse> warehouses;
                    EFailCode eFailCode;
                    bool successed = cWarehouseController.GetModelList("", "", out warehouses, out eFailCode);
                    if (successed && warehouses.Count > 0)
                    {
                        foreach (var warehouse in warehouses)
                        {
                            if (!Global.dictWareHouseAbutment.ContainsKey(warehouse.WareHouseID))
                            {

                                Global.dictWareHouseAbutment[warehouse.WareHouseID] = new WareHouseAbutment()
                                {
                                    WareHouseLocation = warehouse.WareHouseID,
                                    OrderID = "",
                                    PlatType = warehouse.RegionSeq,
                                    AbutmentStatus = AbutmentStatus.Unready,
                                    RelatedWareHouseLocation = warehouse.ProductRegion,
                                    FinishTime = DateTime.MinValue
                                };
                                int.TryParse(warehouse.RackID, out int tempCallAGVType);
                                Global.dictWareHouseAbutment[warehouse.WareHouseID].CallAGVType = tempCallAGVType > 1 ? tempCallAGVType : 1;
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    CLog.Instance.WriteLog("初始化库位对接信息异常", ex.ToString());
                }
                //InitTimer();//定时器
                // 打开用户线程
                new Task(() => ScanIOTransmissionAbutmentTask()).Start();
                new Task(() => ScanReportMaterialLocationResponse()).Start(); 
                CLog.Instance.WriteLog("PMS启动", "初始化成功");

                //MES任务
                //_TaskThread = new Thread(TaskThread);
                //_TaskThread.IsBackground = true;
                //_TaskThread.Start();

                //_PadThread = new Thread(PadThread);
                //_PadThread.IsBackground = true;
                //_PadThread.Start();
            }
        }

        private void InitTransformNum()
        {

        }
        #region 定时器
        System.Timers.Timer timer;
        private void InitTimer()
        {
            timer = new System.Timers.Timer(1500);
            timer.AutoReset = true;
            timer.Enabled = true;
            timer.Elapsed += new System.Timers.ElapsedEventHandler(UpdateTask);
        }
        private void UpdateTask(object sender, System.Timers.ElapsedEventArgs e)
        {
            timer.Stop();
            try
            {
                List<OrderData> sd = new List<OrderData>();
                bool yes = _OrderDataController.GetDefaultOrder(out sd);
                if (yes)
                {
                    StringBuilder sb = new StringBuilder();
                    foreach (var item in sd)
                    {
                        sb.Append($" update  ");
                        sb.Append($" PMS_mid_OrderData ");
                        sb.Append($" set  ");
                        sb.Append($" OrderState=1 ");
                        sb.Append($" where OrderID='{item.OrderID}'  ");
                    }
                    int Edit = ConDataBase_PMS.sqlNonQuery(sb.ToString());
                    if (Edit > 0)
                        CLog.Instance.WriteLog("默认状态更新", $"更新成功：数量：{Edit}");
                }
            }
            catch (Exception ex)
            {
                string strLog = "TaskAdd:" + ex.StackTrace + ex.Message;
                CPmsControllers.Instance.SystemController.WriteLog("UserError", strLog);
            }
            timer.Start();
        }
        #endregion

        #region 线程方法
        CPmsInterface _PmsInterface = new CPmsInterface();
        private void TaskThread()
        {
            while (true)
            {
                try
                {
                    ScanIOTransmissionDevices();
                    AddTask();
                    Thread.Sleep(1000);
                }
                catch (Exception ex)
                {
                    CLog.Instance.WriteLog("TaskThread", $"异常：【{ex.Message}】异常明细[{ex.StackTrace}]");
                    Thread.Sleep(5000);
                }
            }
        }
        /// <summary>
        /// 暂未采用
        /// </summary>
        private void ScanIOTransmissionAbutmentTask()
        {
            List<string> listEmptyWareHouse = new List<string>();
            List<string> listFullWareHouse = new List<string>();
            List<string> listEmptyCallWareHouse = new List<string>();
            while (true)
            {
                listEmptyWareHouse.Clear();
                listFullWareHouse.Clear();
                listEmptyCallWareHouse.Clear();
                try
                {
                    foreach (var item in Global.dictWareHouseAbutment.Values)
                    {
                        List<Pms.InternalInterface.Models.OrderData> OrderDataListTUMO0;
                        EFailCode eFailCodeTUMO0;
                        _OrderDataController.GetOrderList($" OrderID='{item.OrderID}' and OrderState!=255 ", "", out OrderDataListTUMO0, out eFailCodeTUMO0);
                        if (OrderDataListTUMO0.Count < 1)
                        {
                            item.OrderID = "";
                            item.AbutmentStatus = AbutmentStatus.Unready;
                        }
                    }
                }
                catch
                {

                }
                try
                {
                    #region 
                    if (DeviceManager.listIOTransmissionDevice != null)
                    {
                       
                        foreach (var item in DeviceManager.listIOTransmissionDevice)
                        {
                            if (Global.dictWareHouseAbutment.ContainsKey(item.Name))
                            {
                                if (Global.dictWareHouseAbutment[item.Name].AbutmentStatus == AbutmentStatus.Unready)
                                {
                                    item.Y1 = false;
                                    item.Y2 = false;
                                    item.Y3 = false;
                                    item.Y4 = false;
                                    item.Y5 = false;
                                    item.Y6 = false;
                                    item.Y7 = false;
                                    item.Y8 = false;
                                }
                                else
                                {
                                    continue;
                                }
                                if (Global.dictWareHouseAbutment.ContainsKey(item.Name))
                                {
                                    if (item.X1 && item.X3)
                                    {
                                        if (Global.dictWareHouseAbutment[item.Name].PlatType == 2)//组装机
                                        {
                                            if (!listEmptyWareHouse.Contains(item.Name))
                                            {
                                                listEmptyWareHouse.Add(item.Name);
                                            }
                                        }
                                        else if (Global.dictWareHouseAbutment[item.Name].PlatType == 1)//注塑机
                                        {
                                            if (!listFullWareHouse.Contains(item.Name))
                                            {
                                                listFullWareHouse.Add(item.Name);
                                            }
                                        }
                                    }
                                    else if(item.X3&& Global.dictWareHouseAbutment[item.Name].CallAGVType==16&& item.Name.ToLower().Contains("down"))
                                    {
                                        if (!listEmptyCallWareHouse.Contains(item.Name))
                                        {
                                            listEmptyCallWareHouse.Add(item.Name);
                                        }
                                    }
                                }
                            }
                        }
                        int countEmpty = listEmptyWareHouse.Count;
                        int countFull = listFullWareHouse.Count;
                        int countEmptyCall = listEmptyCallWareHouse.Count;
                        if (countFull > 0)//countEmpty > 0 &&
                        {
                            foreach (var item in listFullWareHouse)
                            {
                                //if (listEmptyWareHouse.Count > 0)
                                {
                                    string tempEmptyWareHouse = Global.dictWareHouseAbutment[item].RelatedWareHouseLocation;//listEmptyWareHouse.First()
                                    if (string.IsNullOrEmpty(tempEmptyWareHouse))
                                    {
                                        continue;
                                    }
                                    if (Global.dictWareHouseAbutment[item].FinishTime.AddSeconds(30) > DateTime.Now)
                                    {
                                        continue;
                                    }
                                    COrderInfo sOrder = new COrderInfo();
                                    sOrder.OrderID = "HLD" + "_" + DateTime.Now.ToString("yyyyMMddHHmmssfff");
                                    sOrder.CalledTime = DateTime.Now;
                                    sOrder.OrderState = EOrderState.Added;
                                    sOrder.BookTemplateID = "CallBox";
                                    sOrder.PosArr = new string[] { item, tempEmptyWareHouse };
                                    sOrder.Reserved1 = item;
                                    sOrder.Reserved2 = tempEmptyWareHouse;
                                    sOrder.PosArrLength = sOrder.PosArr.Length;
                                    sOrder.CarrierType = Global.dictWareHouseAbutment[item].CallAGVType;
                                    EFailCode failcode;
                                    string strMsg;
                                    bool Ret = _OrderDataController.OrderAdd(sOrder, out strMsg, out failcode);
                                    if (Ret)
                                    {
                                        Global.dictWareHouseAbutment[item].FinishTime = DateTime.Now;
                                        Global.dictWareHouseAbutment[tempEmptyWareHouse].OrderID = sOrder.OrderID;
                                        Global.dictWareHouseAbutment[tempEmptyWareHouse].AbutmentStatus = AbutmentStatus.Assigning;
                                        Global.dictWareHouseAbutment[item].OrderID = sOrder.OrderID;
                                        Global.dictWareHouseAbutment[item].AbutmentStatus = AbutmentStatus.Assigning;
                                        CLog.Instance.WriteLog("IOTransmissionAbutmentTaskList", string.Format("叫料任务添加成功，叫料点：{0}，任务模板：{1}", tempEmptyWareHouse + "," + item, sOrder.BookTemplateID));
                                    }
                                    else
                                    {
                                        CLog.Instance.WriteLog("IOTransmissionAbutmentTaskList", string.Format("叫料任务添加失败，叫料点：{0}，任务模板：{1},错误码：{2}，错误信息：{3}", tempEmptyWareHouse + "," + item, sOrder.BookTemplateID, failcode.ToString(), string.IsNullOrEmpty(strMsg) ? "" : strMsg));
                                    }
                                    listEmptyWareHouse.Remove(tempEmptyWareHouse);
                                }
                                Thread.Sleep(100);

                            }
                        }
                        if (countEmptyCall > 0)
                        {
                            foreach (var item in listEmptyCallWareHouse)
                            {
                                //if (listEmptyWareHouse.Count > 0)
                                {
                                    string tempFullWareHouse = Global.dictWareHouseAbutment[item].RelatedWareHouseLocation;//listEmptyWareHouse.First()
                                    if (string.IsNullOrEmpty(tempFullWareHouse))
                                    {
                                        continue;
                                    }
                                    if (Global.dictWareHouseAbutment[tempFullWareHouse].FinishTime.AddSeconds(30) > DateTime.Now)
                                    {
                                        continue;
                                    }
                                    COrderInfo sOrder = new COrderInfo();
                                    sOrder.OrderID = "HLD" + "_" + DateTime.Now.ToString("yyyyMMddHHmmssfff");
                                    sOrder.CalledTime = DateTime.Now;
                                    sOrder.OrderState = EOrderState.Added;
                                    sOrder.BookTemplateID = "CallBox";
                                    sOrder.PosArr = new string[] { tempFullWareHouse, item  };
                                    sOrder.Reserved1 =tempFullWareHouse ;
                                    sOrder.Reserved2 = item;
                                    sOrder.PosArrLength = sOrder.PosArr.Length;
                                    sOrder.CarrierType = Global.dictWareHouseAbutment[tempFullWareHouse].CallAGVType;
                                    EFailCode failcode;
                                    string strMsg;
                                    bool Ret = _OrderDataController.OrderAdd(sOrder, out strMsg, out failcode);
                                    if (Ret)
                                    {
                                        Global.dictWareHouseAbutment[item].FinishTime = DateTime.Now;
                                        Global.dictWareHouseAbutment[tempFullWareHouse].OrderID = sOrder.OrderID;
                                        Global.dictWareHouseAbutment[tempFullWareHouse].AbutmentStatus = AbutmentStatus.Assigning;
                                        Global.dictWareHouseAbutment[item].OrderID = sOrder.OrderID;
                                        Global.dictWareHouseAbutment[item].AbutmentStatus = AbutmentStatus.Assigning;
                                        CLog.Instance.WriteLog("IOTransmissionAbutmentTaskList", string.Format("叫料任务添加成功，叫料点：{0}，任务模板：{1}", tempFullWareHouse + "," + item, sOrder.BookTemplateID));
                                    }
                                    else
                                    {
                                        CLog.Instance.WriteLog("IOTransmissionAbutmentTaskList", string.Format("叫料任务添加失败，叫料点：{0}，任务模板：{1},错误码：{2}，错误信息：{3}", tempFullWareHouse + "," + item, sOrder.BookTemplateID, failcode.ToString(), string.IsNullOrEmpty(strMsg) ? "" : strMsg));
                                    }
                                }
                                Thread.Sleep(100);
                            }
                        }

                    }
                    #endregion
                }
                catch (Exception ex)
                {
                    CLog.Instance.WriteLog("IOTransmissionAbutmentTaskListException", ex.ToString());
                }
                Thread.Sleep(50);
            }
        }

        DateTime dtReportTime = DateTime.MinValue;
        private void ScanReportMaterialLocationResponse()
        {
            while (true)
            {
                try
                {
                    if (dtReportTime.AddMinutes(5) < DateTime.Now)
                    {
                        StringBuilder sb = new StringBuilder();
                        sb.Append($" SELECT * from");
                        sb.Append($" t_wh_locationProperty");
                        sb.Append($" where Status='2'");
                        DataTable dt_Task = ConDataBase_WMS.reDt(sb.ToString());

                        if (dt_Task != null && dt_Task.Rows != null && dt_Task.Rows.Count > 0)
                        {

                            ReportMaterialLocationRequest[] reportMaterialLocationRequests = new ReportMaterialLocationRequest[dt_Task.Rows.Count];
                            for (int i = 0;i< dt_Task.Rows.Count; i++)
                            {
                                DataRow row =dt_Task.Rows[i];
                                ReportMaterialLocationRequest reportMaterialLocationRequest = new ReportMaterialLocationRequest();
                                reportMaterialLocationRequest.boxno = row["Attribute5"].ToString();
                                reportMaterialLocationRequest.cwdm= row["LocationCode"].ToString();
                                reportMaterialLocationRequest.jlrq = string.IsNullOrEmpty(row["Attribute6"].ToString())? DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"): row["Attribute6"].ToString();
                                reportMaterialLocationRequests[i] = reportMaterialLocationRequest;
                            }
                            SCL_DMS_WebServiceHelper.ReportMaterialStation(reportMaterialLocationRequests);
                            //reportMaterialLocationRequest.
                        }
                        dtReportTime = DateTime.Now;
                    }
                }
                catch
                {

                }

            }
        }
        private void ScanElevatorTask()
        {
            while (true)
            {
                try
                {
                    StringBuilder sb = new StringBuilder();
                    sb.Append($" SELECT * from");
                    sb.Append($" t_wh_locationProperty");
                    sb.Append($" where Status='2' and WareHouseCode=3");
                    DataTable dt_Task = ConDataBase_WMS.reDt(sb.ToString());

                    if (dt_Task != null && dt_Task.Rows != null && dt_Task.Rows.Count > 0)
                    {
                        DataRow dataRowTask = dt_Task.Rows[0];
                        string locationcode = dataRowTask["LocationCode"].ToString();
                        string targetlocationcode = dataRowTask["LocationCode"].ToString();
                        string materialid = dataRowTask["Attribute5"].ToString();
                    }
                }
                catch
                {

                }
            }
        }
        IOTransmissionDevice device;
        private COrderDataController taskControl = new COrderDataController();
        CSystemController _SystemController = new CSystemController();
        void ScanIOTransmissionDevices()
        {
            try
            {
                foreach (var device in DeviceManager.listIOTransmissionDevice)
                {
                    if (device.Carrier > 0)
                    {
                        cCCarrierController.GetCarrier(device.Carrier, out CCarrier cCarrier);
                        if (cCarrier != null && !cCarrier.InSystem)
                        {
                            device.Carrier = 0;
                            device.Y1 = false;
                            device.Y2 = false;
                        }

                    }
                }
            }
            catch
            {

            }
        }
        private void AddTask()
        {
            try
            {
                StringBuilder sb = new StringBuilder();
                DataTable dt_Task = new DataTable();
                string TaskStation = null;
                string[] posArr;
                string strMsg;
                EFailCode failcode;
                //while (true)
                //{
                //for (int i = 0; i < dt_IOT.Rows.Count; i++)
                //{
                //    try
                //    {
                //        device = DeviceManager.GetRollerDevice(dt_IOT.Rows[i]["Name"].ToString());
                //        if (!device.Y1 || !device.Y2)
                //            continue;
                //    }
                //    catch (Exception ex)
                //    {
                //        CLog.Instance.WriteLog("对接盒_Error", $"读取Y1&Y2信号异常：【{ex.Message}】异常明细[{ex.StackTrace}]");
                //    }
                //}
                try
                {
                    sb.Append($" SELECT * from");
                    sb.Append($" MesOrderTask");
                    sb.Append($" where actaionStatus='0'");
                    dt_Task = ConDataBase_PMS.reDt(sb.ToString());
                    if (dt_Task != null && dt_Task.Rows != null && dt_Task.Rows.Count > 0)
                    {
                        for (int i = 0; i < dt_Task.Rows.Count; i++)
                        {
                            COrderInfo task1 = new COrderInfo();
                            TaskStation = $"{dt_Task.Rows[i]["targetPoint"].ToString()}";
                            posArr = TaskStation.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                            if (posArr == null || posArr.Length < 2)
                            {
                                string temp = posArr == null ? "Null" : posArr.ToString();
                                CLog.Instance.WriteLog("TaskAdd_Error", $"posArr:{temp}格式错误");
                                return;
                            }
                            for (int k = 0; k < dt_IOT.Rows.Count; k++)
                            {
                                try
                                {
                                    device = DeviceManager.GetRollerDevice(posArr[1]);
                                    if (device == null)
                                    {
                                        CLog.Instance.WriteLog("对接盒_Error", $"找不到终点库位:{posArr[1]},对应的对接盒设置");
                                        continue;
                                    }
                                    //IOTransmissionDevice deviceUp = DeviceManager.GetRollerDevice(posArr[0]);
                                    //if (deviceUp == null)
                                    //{
                                    //    CLog.Instance.WriteLog("对接盒_Error", $"找不到起点库位:{posArr[0]},对应的对接盒设置");
                                    //    continue;
                                    //}

                                    //_SystemController.WriteLog("对接盒信号", $"\nOrderID:[{task1.OrderID}]\nName:[{device.Name}]\nIPaddress:[{device.IPAddress}]\nY1信号:[{device.Y1}]\nY2信号:[{device.Y2}]");
                                    //if (device.Y1 && device.Y2)
                                    {
                                        task1.OrderID = dt_Task.Rows[i]["taskChainCode"].ToString();
                                        task1.ParentOrderID = $"{posArr[1]}";
                                        task1.PosArr = posArr;
                                        task1.PosArrLength = posArr.Length;
                                        task1.CalledTime = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                                        task1.BookTemplateID = "CallBox";
                                        task1.OrderState = EOrderState.Added;
                                        bool taskflag = taskControl.OrderAdd(task1, out strMsg, out failcode);
                                        if (taskflag)
                                        {
                                            sb.Clear();
                                            sb.Append($" update MesOrderTask");
                                            sb.Append($" set actaionStatus=1");
                                            sb.Append($" where");
                                            sb.Append($" taskChainCode = '{task1.OrderID}'");
                                            int flag = ConDataBase_PMS.sqlNonQuery(sb.ToString());
                                            if (flag > 0)
                                            {
                                                _SystemController.WriteLog("TaskStatus_Edit", $"taskChainCode:[{task1.OrderID}]actaionStatus:[{1}]");
                                            }
                                            _SystemController.WriteLog("添加AGV任务成功", $"OrderID:[{task1.OrderID}]PosArr:[{TaskStation}]CalledTime:[{task1.CalledTime}]");
                                        }
                                        //else
                                        //    _SystemController.WriteLog("添加AGV任务失败", $"OrderID:[{task1.OrderID}]PosArr:[{TaskStation}]CalledTime:[{task1.CalledTime}]");
                                    }
                                }
                                catch (Exception ex)
                                {
                                    CLog.Instance.WriteLog("对接盒_Error", $"读取Y1&Y2信号异常：【{ex.Message}】异常明细[{ex.StackTrace}]");
                                }
                            }
                        }
                        //if (dt_priority.Length > 0)
                        //{
                        //}
                        // else
                        //{
                        //    dt_priority = dt_Task.Select($"  Attribute2='2' ");
                        //    if (dt_priority.Length > 0)
                        //    {
                        //        COrderInfo task1 = new COrderInfo();
                        //        TaskStation = $"{dt_IOT.Rows[0]["Name"].ToString()},{dt_priority[0]["Attribute1"].ToString()}";
                        //        posArr = TaskStation.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                        //        task1.OrderID = dt_IOT.Rows[0]["Name"].ToString();
                        //        task1.ParentOrderID = $"{dt_IOT.Rows[0]["Name"].ToString()},{dt_priority[0]["Attribute1"].ToString()}";
                        //        task1.PosArr = posArr;
                        //        task1.PosArrLength = posArr.Length;
                        //        task1.BookTemplateID = "CallBox";
                        //        task1.CalledTime = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                        //        task1.OrderState = EOrderState.Added;
                        //        bool taskflag = taskControl.OrderAdd(task1, out strMsg, out failcode);
                        //        if (taskflag)
                        //            _SystemController.WriteLog("添加AGV任务成功", $"OrderID:[{task1.OrderID}]PosArr:[{TaskStation}]CalledTime:[{task1.CalledTime}]");
                        //        else
                        //            _SystemController.WriteLog("添加AGV任务失败", $"OrderID:[{task1.OrderID}]PosArr:[{TaskStation}]CalledTime:[{task1.CalledTime}]");
                        //    }
                        //}
                    }
                }
                catch (Exception ex)
                {
                    CLog.Instance.WriteLog("查询任务", $"异常:[{ex.Message}]异常明细[{ex.StackTrace}]");
                }
                //}
            }
            catch (Exception ex)
            {
                CLog.Instance.WriteLog("AddTask", $"异常:[{ex.Message}]异常明细[{ex.StackTrace}]");
            }
        }
        #endregion
    }
}
