﻿using Pms.Interface;
using Pms.Interface.ResultModels;
using Pms.WebApiHost.Models;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;

namespace Pms.WebApiHost.Controllers
{
    //[RoutePrefix("AgvWebApi")]
    public class AgvController : ApiController
    {
        CPmsInterface _PmsInterface = new CPmsInterface();

        /// <summary>
        /// 任务添加接口
        /// </summary>
        /// <param name="sRequestTaskInfo"></param>
        //[Route("OrderAdd")]
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> OrderAdd([FromBody] RequestOrderInfo sRequestOrderInfo)
        {
            //return Json(_PmsInterface.OrderAdd(sOrderInfo));
            Result res = new Result();

            StringBuilder sb = new StringBuilder();
            sb.Append($" select COUNT(*) MsgCount from");
            sb.Append($" MesOrderTask");
            sb.Append($" where actaionStatus=0");
            sb.Append($" and");
            sb.Append($" (targetPoint='{sRequestOrderInfo.PosArr}' OR taskChainCode='{sRequestOrderInfo.OrderID}')");
            DataTable dt = ConDataBase_PMS.reDt(sb.ToString());
            if (int.Parse(dt.Rows[0]["MsgCount"].ToString()) == 0)
            {
                sb.Clear();
                sb.Append($" select * from");
                sb.Append($" PMS_bas_Warehouse");
                sb.Append($" where");
                sb.Append($" WareHouseID='{sRequestOrderInfo.PosArr}'");
                DataTable dt_TaskStation = ConDataBase_PMS.reDt(sb.ToString());
                if (dt_TaskStation != null && dt_TaskStation.Rows != null && dt_TaskStation.Rows.Count > 0)
                {
                    sb.Clear();
                    sb.Append($" insert into  ");
                    sb.Append($" MesOrderTask");
                    sb.Append($" (taskChainCode,targetPoint)");
                    sb.Append($" values");
                    sb.Append($" ('{sRequestOrderInfo.OrderID}', '{sRequestOrderInfo.PosArr},{dt_TaskStation.Rows[0]["ProductRegion"].ToString()}')");//DownStation
                    int flag = ConDataBase_PMS.sqlNonQuery(sb.ToString());
                    if (flag > 0)
                    {
                        res.resCode = (int)EResultCode.Successed;
                        res.resData = DateTime.Now.ToString();
                        res.resMsg = $"OrderID:[{sRequestOrderInfo.OrderID}]任务点位:[{sRequestOrderInfo.PosArr}]添加成功！";
                        return Json(res);
                    }
                }
                res.resCode = (int)EResultCode.Failed;
                res.resData = DateTime.Now.ToString();
                res.resMsg = $"OrderID:[{sRequestOrderInfo.OrderID}]任务点位:[{sRequestOrderInfo.PosArr}]未绑定下料点,不执行任务！";
                return Json(res);
            }
            else
            {
                res.resCode = (int)EResultCode.ParameterError;
                res.resData = DateTime.Now.ToString();
                res.resMsg = $"任务点位:[{sRequestOrderInfo.PosArr}]未执行完成,不接收新任务。";
                return Json(res);
            }
            #region
            //if (!DateTime.TryParse(sRequestOrderInfo.CallTime, out CallTime))
            //{
            //    res.resCode = (int)EResultCode.ParameterError;
            //    res.resData = CallTime.ToString();
            //    res.resMsg = "ParameterError：Calledtime format error！";
            //    return Json(res);
            //}
            //string[] PosArr;
            //PosArr = sRequestOrderInfo.PosArr.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

            //OrderInfo sOrderInfo = new OrderInfo();
            //sOrderInfo.OrderID = sRequestOrderInfo.OrderID;
            //sOrderInfo.ParentOrderID = sRequestOrderInfo.ParentOrderID;
            //sOrderInfo.OrderPriority = sRequestOrderInfo.Priority;
            //sOrderInfo.CarrierType = sRequestOrderInfo.CarrierType;

            //sOrderInfo.BookTemplateID = sRequestOrderInfo.BookTemplateID;
            //sOrderInfo.OrderType = sRequestOrderInfo.Type;

            //sOrderInfo.CalledTime = CallTime;

            //sOrderInfo.PosArr = PosArr;
            //sOrderInfo.PosArrLength = sRequestOrderInfo.PosArrLength;
            //sOrderInfo.OtherOrderData = sRequestOrderInfo.OtherOrderData;

            //return Json(_PmsInterface.OrderAdd(sOrderInfo));
            #endregion
        }

        //        {
        //"resCode": 20000,
        //"resMsg": "任务添加成功!"
        //}
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> TaskAdd([FromBody] RequestTaskInfo sRequestTaskInfo)
        {
            //return Json(_PmsInterface.OrderAdd(sOrderInfo));
            Result res = new Result();
            //res.resCode = 20000;
            //res.resMsg = "";
            //return Json(res);
            if (string.IsNullOrEmpty(sRequestTaskInfo.StartStore))
            {
                res.resCode = 20001;
                res.resMsg = "取货仓位为空";
                return Json(res);
            }
            if (string.IsNullOrEmpty(sRequestTaskInfo.EndStore))
            {
                res.resCode = 20001;
                res.resMsg = "放货仓位为空";
                return Json(res);
            }
            OrderInfo sOrderInfo = new OrderInfo();
            sOrderInfo.OrderID = sRequestTaskInfo.TaskId;
            //sOrderInfo.ParentOrderID = sRequestTaskInfo.TaskId;
            sOrderInfo.CarrierType = sRequestTaskInfo.StartStore.StartsWith("B3") ? 8 : 4;


            string[] PosArr = { sRequestTaskInfo.StartStore, sRequestTaskInfo.EndStore };
            sOrderInfo.BookTemplateID = "SCL_UnCrossFloor";
            //if (sRequestTaskInfo.StartStore.ToLower().Contains("elevator"))
            //{
            //    sOrderInfo.BookTemplateID = "SCL_UnCrossFloor1";
            //}
            //else if (sRequestTaskInfo.EndStore.ToLower().Contains("elevator"))
            //{
            //    sOrderInfo.BookTemplateID = "SCL_UnCrossFloor3";
            //}
            sOrderInfo.CalledTime = DateTime.Now;
            sOrderInfo.PosArr = PosArr;
            sOrderInfo.PosArrLength = 2;
            //sOrderInfo.
            sOrderInfo.OtherOrderData = sRequestTaskInfo.MaterlalId;
            sOrderInfo.Remark = sRequestTaskInfo.MaterlalId;
            Result tempResult = _PmsInterface.OrderAdd2(sOrderInfo, 1);
            if (tempResult.resCode == 0)
            {
                res.resCode = 20000;
                res.resMsg = "任务添加成功!";
            }
            else
            {
                res.resCode = 20001;
                res.resMsg = tempResult.resMsg;
            }
            return Json(res);
        }

        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> MidOrderAdd([FromBody] RequestMidOrder sRequsetOrder)
        {
            Result res = new Result();

            res.ResTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            res.BizCode = EBizCode.MidOrderAdd.ToString();
            res.resData = "";

            if (sRequsetOrder.OrderID == "" || sRequsetOrder.OrderID == null)
            {
                res.resCode = (int)EResultCode.ParameterError;
                //res.resMsg = "参数错误：OrderID不能为空!";
                res.resMsg = "ParameterError：OrderID can't be empty!";
                return Json(res);
            }

            DateTime CallTime;
            if (!DateTime.TryParse(sRequsetOrder.CallTime, out CallTime))
            {
                res.resCode = (int)EResultCode.ParameterError;
                //res.resMsg = "参数错误：CalledTime时间格式错误！";
                res.resMsg = "ParameterError：Calledtime format error！";
                return Json(res);
            }

            MidOrderInfo sMidOrder = new MidOrderInfo();

            sMidOrder.State = "Default"; // DEFAULT 状态 数据还未经过初处理。
            sMidOrder.OrderID = sRequsetOrder.OrderID;
            sMidOrder.Priority = sRequsetOrder.Priority;

            sMidOrder.Type = sRequsetOrder.Type;
            sMidOrder.CalledTime = CallTime;
            sMidOrder.CreateTime = DateTime.Now;
            sMidOrder.PosQue = sRequsetOrder.PosArr;
            sMidOrder.PosQueLength = sRequsetOrder.PosArrLength;
            sMidOrder.CarrierType = sRequsetOrder.CarrierType; // 任务添加的小车类型 任务处理的时候修改

            res = _PmsInterface.MidOrderAdd(sMidOrder);

            return Json(res);
        }
        /// <summary>
        /// 任务取消接口
        /// </summary>
        /// <param name="OrderID"></param>
        /// <returns>false: 取消成功 true：取消请求接收成功</returns>        
        //[Route("OrderCancel")]
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> OrderCancel([FromBody] string OrderID)
        {
            return Json(_PmsInterface.OrderCancel(OrderID));
        }

        /// <summary>
        /// 获取订单状态
        /// </summary>
        /// <param name="OrderID"></param>
        /// <returns></returns>
        //[Route("GetOrder")]
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> GetOrder([FromBody] string OrderID)
        {
            return Json(_PmsInterface.GetOrder(OrderID));
        }

        ///// <summary>
        ///// 获取订单状态
        ///// </summary>
        ///// <param name="OrderID"></param>
        ///// <returns></returns>
        ////[Route("GetOrder")]
        //[AcceptVerbs("Get", "POST")]
        //public JsonResult<Result> GetCarrierOrder([FromBody] int CarrierID)
        //{
        //    return Json(_PmsInterface.GetCarrierOrder(CarrierID));
        //}

        /// <summary>
        /// 获取当前所有执行中任务（历史任务除外）
        /// </summary>
        /// <returns></returns>
        //[Route("GetCurrentOrder")]
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> GetCurrentOrder()
        {
            return Json(_PmsInterface.GetCurrentOrder());
        }

        /// <summary>
        /// 通过AgvID 获取AGV状态
        /// </summary>
        /// <returns></returns>
        //[Route("GetCarrier")]
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> GetCarrier([FromBody] int CarrierID)
        {
            return Json(_PmsInterface.GetCarrier(CarrierID));
        }

        /// <summary>
        /// 获取所有AGV状态
        /// </summary>
        /// <returns></returns>
        [AcceptVerbs("Get", "POST")]
        public JsonResult<Result> GetAllCarrier()
        {
            return Json(_PmsInterface.GetAllCarrier());
        }
    }
}

