﻿using ResetWarning.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ResetWarning
{
    public partial class FrmAlarmSetting : Form
    {
        public FrmAlarmSetting()
        {
            InitializeComponent();
        }

        private void Querry()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($" SELECT");
            sb.Append($" _IP IP地址,_Port 端口号,_ID 报警灯编号");//,_Type 项目类型
            sb.Append($" FROM");
            sb.Append($" T_AlarmTable");
            DataTable dt = ConDataBase_PMS.reDt(sb.ToString());
            dgv1.DataSource = dt;
        }

        private void FrmAlarmSetting_Load(object sender, EventArgs e)
        {
            Querry();
        }

        private void dgv1_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            //自动编号，与数据无关
            Rectangle rectangle = new Rectangle(e.RowBounds.Location.X, e.RowBounds.Location.Y, dgv1.RowHeadersWidth - 4, e.RowBounds.Height);
            TextRenderer.DrawText(e.Graphics, (e.RowIndex + 1).ToString(), dgv1.RowHeadersDefaultCellStyle.Font, rectangle, dgv1.RowHeadersDefaultCellStyle.ForeColor, TextFormatFlags.VerticalCenter | TextFormatFlags.Right);
        }

        private void dgv1_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            int DGVCurrentRow = e.RowIndex;
            if (DGVCurrentRow != -1 && dgv1.Rows[DGVCurrentRow] != null)
            {
                txt_IP.Text = dgv1.Rows[DGVCurrentRow].Cells["IP地址"].Value.ToString().Trim();
                txt_Port.Text = dgv1.Rows[DGVCurrentRow].Cells["端口号"].Value.ToString().Trim();
                //txt_Type.Text = dgv1.Rows[DGVCurrentRow].Cells["项目类型"].Value.ToString().Trim();
                txt_ID.Text = dgv1.Rows[DGVCurrentRow].Cells["报警灯编号"].Value.ToString().Trim();

                lbl_IP.Text = dgv1.Rows[DGVCurrentRow].Cells["IP地址"].Value.ToString().Trim();
                lbl_Port.Text = dgv1.Rows[DGVCurrentRow].Cells["端口号"].Value.ToString().Trim();
                //lbl_Type.Text = dgv1.Rows[DGVCurrentRow].Cells["项目类型"].Value.ToString().Trim();
                lbl_ID.Text = dgv1.Rows[DGVCurrentRow].Cells["报警灯编号"].Value.ToString().Trim();
            }
        }

        private int FindData(string IP, string Port, string ID/*, string Type*/)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($" SELECT Count(*) Counts");
            sb.Append($" FROM T_AlarmTable");
            sb.Append($" where");
            sb.Append($" _IP='{IP}' and _Port='{Port}' and _ID='{ID}'");// and _Type='{Type}'
            DataTable dt = ConDataBase_PMS.reDt(sb.ToString());
            if (dt != null && dt.Rows != null && dt.Rows.Count > 0)
            {
                return int.Parse(dt.Rows[0]["Counts"].ToString());
            }
            return 0;
        }
        private void btn_Update_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txt_ID.Text.Trim()) || string.IsNullOrEmpty(txt_IP.Text.Trim()) || string.IsNullOrEmpty(txt_Port.Text.Trim()))//|| string.IsNullOrEmpty(txt_Type.Text.Trim())
            {
                MessageBox.Show("数据不能为空");
                return;
            }
            if (FindData(txt_IP.Text.Trim(), txt_Port.Text.Trim(), txt_ID.Text.Trim()/*, txt_Type.Text.Trim()*/) > 0)
            {
                MessageBox.Show("数据重复");
                return;
            }
            //int times = 0;
            //if (!int.TryParse(txt_time.Text.Trim(), out times))
            //{
            //    MessageBox.Show($"上报延时只能为整数数字");
            //    txt_time.Text = "0";
            //    return;
            //}
            StringBuilder sb = new StringBuilder();
            sb.Append($" update");
            sb.Append($" T_AlarmTable");
            sb.Append($" set");
            sb.Append($" _IP='{txt_IP.Text.Trim()}',_Port='{txt_Port.Text.Trim()}', _ID='{txt_ID.Text.Trim()}'");//,_Type='{txt_Type.Text.Trim()}'
            sb.Append($" where ");
            sb.Append($" _IP='{lbl_IP.Text.Trim()}' and _Port='{lbl_Port.Text.Trim()}' and _ID='{lbl_ID.Text.Trim()}'");// and _Type='{lbl_Type.Text.Trim()}'
            int flag = ConDataBase_PMS.sqlNonQuery(sb.ToString());
            if (flag > 0)
            {
                MessageBox.Show("更新成功！");
                Querry();
            }
        }
        private void btn_Refresh_Click(object sender, EventArgs e)
        {
            Querry();
        }
    }
}
