﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TaskApp.Log;
using TaskApp.Model;

namespace TaskApp
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }
        DataTable dt = new DataTable();
        #region
        private void PadTask()
        {
            try
            {
                StringBuilder sb = new StringBuilder();
                sb.Append($" select * from CallTask");
                dt = ConDataBase_WMS.reDt(sb.ToString());
                if (dt != null && dt.Rows != null && dt.Rows.Count > 0)
                {
                    dgv_Task.DataSource = dt;
                }
            }
            catch (Exception ex)
            {
                LogNotes.WriteSystemLog_Error($"查询数据异常:异常信息:【{ex.Message}】异常位置:【{ex.StackTrace}】");
                throw;
            }
        }
        private void PadTask(int type)
        {
            try
            {
                StringBuilder sb = new StringBuilder();
                sb.Append($" select * from CallTask where TaskStatus={type}");
                dt = ConDataBase_WMS.reDt(sb.ToString());
                if (dt != null && dt.Rows != null && dt.Rows.Count > 0)
                {
                    dgv_Task.DataSource = dt;
                }
            }
            catch (Exception ex)
            {
                LogNotes.WriteSystemLog_Error($"查询数据异常:异常信息:【{ex.Message}】异常位置:【{ex.StackTrace}】");
                throw;
            }
        }
        #endregion
        private void button1_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(cbx_Type.Text))
            {
                MessageBox.Show("任务类型不能为空！");
                return;
            }
            int type = int.Parse(cbx_Type.Text.Trim());
            PadTask(type);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("是否删除当前选中数据？", "提示", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    StringBuilder sb = new StringBuilder();
                    sb.Append($" delete from CallTask where Id={int.Parse(txt_TaskID.Text)}  ");
                    int flag = ConDataBase_WMS.sqlNonQuery(sb.ToString());
                    if (flag > 0)
                    {
                        txt_TaskID.Clear();
                        txt_TaskLocation.Clear();
                        txt_TaskStatus.Clear();
                        PadTask();
                        LogNotes.WriteSystemLog($"删除Id号[{txt_TaskID.Text}]的任务");
                    }
                    else
                    {
                        MessageBox.Show($"删除Id号[{txt_TaskID.Text}]的任务失败");
                        LogNotes.WriteSystemLog($"删除Id号[{txt_TaskID.Text}]的任务失败【{sb.ToString()}】");
                    }
                }
            }
            catch (Exception ex)
            {
                LogNotes.WriteSystemLog_Error($"删除数据异常:异常信息:【{ex.Message}】异常位置:【{ex.StackTrace}】");
            }
        }

        private void dgv_Task_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                if (e.RowIndex < 0)
                {
                    return;
                }
                txt_TaskID.Text = dt.Rows[e.RowIndex]["Id"].ToString();
                txt_TaskLocation.Text = dt.Rows[e.RowIndex]["LocationCode"].ToString();
                txt_TaskStatus.Text = dt.Rows[e.RowIndex]["TaskStatus"].ToString();
            }
            catch (Exception ex)
            {
                LogNotes.WriteSystemLog_Error($"加载数据异常:异常信息:【{ex.Message}】异常位置:【{ex.StackTrace}】");
            }
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            PadTask();
        }
    }
}
